#include "..\include\winresrc\rc_def.h"
#include "..\include\internls\evrythng.h"
#pragma hdrstop

// m_scan.cpp
// (C) 1993,95 by Heiko Damerow MPG AG "Roentgenbeugung"
/*
- Einlesen alter Datenfiles [Data]
*/

//! von diffr.gruppe kommentiert

#define ContinuousScanCapability
#include <direct.h>
#include "..\include\swintrac\swintrac.h"
#include "..\include\datavisa\datavisa.h"
#include "..\include\workflow\workflow.h"
#include "..\include\detecuse\detecuse.h"
#include "..\include\motrstrg\motrstrg.h"

#include "..\include\difrkmty\difrkmty.h"

#include "..\include\difrkmty\m_scan.h"

int TMDIWindow::WindowId = 0;

#ifdef _WIN32
#define WRITE OF_WRITE
#endif

extern TMain Main;
extern LPDList lpDList;
extern TSteering Steering;
static int nScanTask;

//! FIX Fehler 73
//! Fehlermeldungen
#ifdef GermanVersion
char szMsgFailureScan[] = "Fehler";
char szMessageScan[] = "Meldung";
char szMsgLine101[] = "Einen Standard-Scan mit %s\r\n Bereich (%s >> %s) \r\nstarten ?";
char szMsgLine102[] = "Einen Omega2Theta-Scan mit Omega\r\nvon %s bis %s starten ?";
char szMsgLine103[] = "%smit Omega von %s bis %s starten ?";
char szMsgLine104[] = "Einen kontinuierlichen Scan mit %s\r\n von %s nach %s starten ?";
char szMsgLine105[] = "Es ist ein Fehler aufgetreten. %d";
char szMsgLine106[] = "Die Messung wurde abgeschlossen und gespeichert.";
char szMsgLine107[] = "Die Messung wurde abgeschlossen. Fehler beim Speichern.";
char szMsgLine108[] = "Header ist nicht korrekt";
char szMsgLine109[] = "File existiert nicht !";
char szMsgLine110[] = "Altes Datenfile laden ...";
char szMsgLine111[] = "File wurde nicht geoeffnet !";
char szMsgLine112[] = "Punkte : %d";
char szMsgLine113[] = "Die Messung wurde abgeschlossen.";
char szMsgLine114[] = "Bereiche : %d";

char szMsgLine130[] = "Die Parameter Bereichsgre und Mezeit\nverursachen eine ungltige Geschwindigkeit!";
char szMsgLine131[] = "Die Parameter Bereichsgre, Startpunkt und Endpunkt\nverursachen eine ungltige Mepunkteanzahl!";
char szMsgLine132[] = "Durch die Einbeziehung des Beschleunigungs- bzw.\nBremsweges (%s) kommt es zu ungltigen Motorpositionen!";
#else
char szMsgFailureScan[] = "Failure";
char szMessageScan[] = "Message";
char szMsgLine101[] = "Execute Scan with %s\r\nfrom %s to %s ?";
char szMsgLine102[] = "Do you want to start a Omega2Theta-Scan\r\n with Omega from %s to %s ?";
char szMsgLine103[] = "%swith Omega from %s to %s ?";
char szMsgLine104[] = "Do you want to start a continuous Scan with %s\r\n from %s to %s ?";
char szMsgLine105[] = "There is a failure appeared. %d";
char szMsgLine106[] = "The Measurement is completed\r\nand the data were saved.";
char szMsgLine107[] = "The Measurement is completed.\r\nFailure on saving data.";
char szMsgLine108[] = "Incorrect Header.";
char szMsgLine109[] = "File not exist ! ";
char szMsgLine110[] = "Load old Datafile ...";
char szMsgLine111[] = "File not opened !";
char szMsgLine112[] = "Points : %d";
char szMsgLine113[] = "The Measurement is completed.";
char szMsgLine114[] = "Areas : %d";
char szMsgLine130[] = "The Parameters Areasize and Time\ncauses an invalid Velocity!";
char szMsgLine131[] = "The Parameters Areasize, Startpoint and Endpoint\ncauses an invalid Pointnumber!";
char szMsgLine132[] = "the inclusion of the acceleration or\nbraking distance (%s) causes invalid motorpositions!";
#endif

//! soll Scanstart vor Aufruf einer Einstellungsbox verhindern
//! FIX Fehler 77 static BOOL bScanSetupOk = FALSE;

// #define DEBUG

//*****************************************************************************
//********** Klasse Diffraktometrie ************************
//*****************************************************************************

//! einlesen der Ini-daten zu [Scan] und
//! setzen von default-werten fuer StepScan
//! wird nur durch TScan-konstruktor aufgerufen
TScanParameters::TScanParameters()
{
    char Param[ MaxString ];
    char buf[ MaxString ];
    int idx, mid = mlGetAxis();

    //! setzen von einigen Defaultwerten
    fFailure = 0.02;
    nNumberCycle = 1;
    eSaveFormat = Tupel;
    eScanType = StandardScan;
    bSaveContinuous = FALSE;
    bMonitorUsed = FALSE;
    nMFunctionId = D_DiffractionScan;
	 Device = lpDList->DP();
    //! test ob Monitordetektor angeschlossen ist wenn ja dann monitor setzen
	 //! ansonsten monitor auf akt. Detektor setzen
	 if ( dlIsDeviceValid( MonitorDevice ) )
		  Monitor = lpDList->DP( dlGetIdByName( MonitorDevice ) );
    else
        Monitor = lpDList->DP();
	 //! testet ob Omega-Motor angeschlossen ist
	 //! wenn ja => akt.Motor Omega setzen
	 //! wenn nein => akt. Motor erster verfuegbarer
	 if ( mlIsAxisValid( Omega ) )
	 {
		  nMotor = mlGetIdByName( Omega );
		  mlSetAxis( nMotor );
	 }
	 else
		  nMotor = mlGetAxis();
	 //! setzen von Werten mit ihren Motorspez. Daten ..
	 dArgumentWidth = mGetValue( Width );
	 dArgumentMax = dArgumentWidth * 100.0;
	 dArgumentMin = -dArgumentWidth * 100.0;
	 dSpeed = mGetValue( Speed );
	 nCollectionAmount = 100;
   //! 2thetawert initialisieren (symmetr. reflex)
   d2ThetaStart = 2.0 * dArgumentMin;
    //! auslesen von ExposureTime,ExposureCounts,DynamicStepWidth aus Scan-Teil
	 //! in der Ini-Datei
	 GetPrivateProfileString( "Scan", "ExposureTime", "1.0", buf, MaxString,
									  GetCFile() );
	 fMaxTime = atof( buf );
	 GetPrivateProfileString( "Scan", "ExposureCounts", "10000", buf, MaxString,
									  GetCFile() );
	 dwMaxCounts = atol( buf );
	 //! wenn im inifile CreateIniDefaults=1 => dann ExposureCounts in Ini-File
	 //! speichern
	 if ( CreateDefaults() )
		  WritePrivateProfileString( "Scan", "ExposureCounts", buf, GetCFile() );
	 //! einlesen der Level fuer Schrittweitensteuerung aus ini-datei
	 //! (falls exist.)
	 idx = 0;
	 //! Aenderung Dynamische Schrittweite
	 bDynamicStepWidth = FALSE;
	 //! einlesen der Level-Werte aus Ini-File
	 //! wenn nicht vorhanden, Default-Werte setzen
	 for (idx; idx<nMaxScaleIdx; idx++)
	 {
		char buf2[MaxString];
		sprintf( Param, "Level%d", idx );
		sprintf(buf2, "%f %f", (float)(idx+1)*1000,(float) 1.0);
		GetPrivateProfileString( "Scan", Param, buf2, buf, MaxString, GetCFile() );
		sscanf( buf, "%f %f", &Scaler[ idx ], &Scaler[ idx + nMaxScaleIdx ] );
	 }
	 //! SaveOnReady aus INI holen
	 bSaveOnReady = GetPrivateProfileInt( "Scan", "SaveOnReady", 1, GetCFile() );
	 //! setzt die Achse, die auch beim Aufruf des Konstr. gesetzt war
	 mlSetAxis( mid );
};

//! registr. des ScanFensters und das ScanFensterMenue erstellen
TScan::TScan( void ) : TPlotData(), TScanParameters()
{
	 //! nicht von diffr.gruppe auskommentiert
	 //! alt HMENU hM1,hM2;
	 HMENU hM2;
	 bInterrupted = FALSE;
	 bMacroRunning = FALSE;

	 // Registrieren der Kindfenster-Klasse
	 TMDIWindow::RegisterWnd();
	 WindowType = W_DiffractionWindow;
	 bMeasurementActive = FALSE;
	 //! erstellen der menueeintraege des Scanfensters
	 TheMenu = CreatePopupMenu();
	 //! nicht von diffr.gruppe auskommentiert
	 //! alt hM1 = CreatePopupMenu();
	 hM2 = CreatePopupMenu();
	 AppendMenu( TheMenu, MF_STRING, cm_SetupStepScan, "Setup &StepScan..." );

	 //! dieses if eingefuegt, damit bei eingelesenem dtnfile keine Setupmenuaufruf moeglich
	 if (eSaveFormat==dtnFile) EnableMenuItem(TheMenu,cm_SetupStepScan,MF_GRAYED);
	 else EnableMenuItem(TheMenu,cm_SetupStepScan,MF_ENABLED);

	 AppendMenu( TheMenu, MF_STRING, cm_SetupContinuousScan,
					 "Setup &ContinuousScan..." );
#ifndef ContinuousScanCapability
	 EnableMenuItem( TheMenu, cm_SetupContinuousScan, MF_GRAYED );
#endif
#ifdef GermanVersion
	 AppendMenu( TheMenu, MF_STRING, cm_ShowCurveParam,
					 "&Darstellungs-Optionen..." );
	 AppendMenu( TheMenu, MF_STRING, cm_InitializeScan, "&Scan starten" );
	 AppendMenu( TheMenu, MF_SEPARATOR, 0, NULL );
	 AppendMenu( hM2, MF_STRING, cm_FreezeCurve, "&Fixieren" );
	 AppendMenu( hM2, MF_STRING, cm_KillSecondCurve, "&Loeschen" );
	 AppendMenu( hM2, MF_STRING, cm_SaveSecondCurve, "&Speichern" );
#else
	 AppendMenu( TheMenu, MF_STRING, cm_ShowCurveParam, "&Visualising-Options..." );
	 AppendMenu( TheMenu, MF_STRING, cm_InitializeScan, "&Scan execute" );
	 AppendMenu( TheMenu, MF_SEPARATOR, 0, NULL );
	 AppendMenu( hM2, MF_STRING, cm_FreezeCurve, "&Fixing" );
	 AppendMenu( hM2, MF_STRING, cm_KillSecondCurve, "&Delete" );
	 AppendMenu( hM2, MF_STRING, cm_SaveSecondCurve, "&Save" );
#endif
	 AppendMenu( TheMenu, MF_POPUP, ( WORD ) hM2, "Sca&n" );
	 //! speicher fuer 50 Messpunkte reservieren und Curve initializieren
	 MainCurve = ( TCurve* ) new TCurve( 50 );
	 //! FIX Fehler 77
	 bScanSetupOk = FALSE;

};

//! loeschen der Kurve,des Menues und speichern von Werten in der Ini-Datei
TScan::~TScan()
{
	 char buf[ MaxString ];
	 RECT rc, rcm;

	 //! loeschen der Kurve
	 delete MainCurve;
	 //! loeschen des Menues
	 DestroyMenu( TheMenu );
	 //! anhalten des Detektor + Det. neustarten
	 mSetCorrectionState( FALSE );
	 Device->MeasureStop();
	 Device->SetHost( NULL );
	 Device->MeasureStart();
	 //! ermitteln der Pos. des Scanfensters + speichern der Koord., des aktuellen
	 //! Verzeichnisses, der ExposureTime und von 'SaveOnReady' im Ini-file
	 GetWindowRect( GetFrameHandle(), &rcm );
	 GetWindowRect( hWndChild, &rc );
	 sprintf( buf, "%d", rc.left - rcm.left - 4 );
	 WritePrivateProfileString( "Scan", "xo", buf, GetCFile() );
	 sprintf( buf, "%d", rc.top - rcm.top - 42 );
	 WritePrivateProfileString( "Scan", "yo", buf, GetCFile() );
	 sprintf( buf, "%d", rc.right - rc.left );
	 WritePrivateProfileString( "Scan", "dx", buf, GetCFile() );
	 sprintf( buf, "%d", rc.bottom - rc.top );
	 WritePrivateProfileString( "Scan", "dy", buf, GetCFile() );
	 WritePrivateProfileString( "Scan", "DataPath", szDataPath, GetCFile() );
	 sprintf( buf, "%.2f", fMaxTime );
	 WritePrivateProfileString( "Scan", "ExposureTime", buf, GetCFile() );
	 sprintf( buf, "%d", bSaveOnReady );
	 WritePrivateProfileString( "Scan", "SaveOnReady", buf, GetCFile() );
	 //! Aenderung Dynamische Schrittweite
	 //! schreiben der aktuellen Einstellungen fuer Dyn. Schrittweite ins Ini-File
	 for (int idx=0; idx<nMaxScaleIdx; idx++)
	 {
		char Param[ MaxString ];
		sprintf( Param, "Level%d", idx );
		sprintf(buf, "%.0f %.2f", Scaler[ idx ], Scaler[ idx + nMaxScaleIdx ]);
		WritePrivateProfileString( "Scan", Param, buf, GetCFile() );
	 }
	 //! registr. des Scanfenster als Kindfenster und sein handle geloescht
	 Main.hScanWindow = NULL;
	 Main.ScanWindow = NULL;
};


//! loescht aktuelle Kurve + baut StepScanfenster neu auf
//! Rueckkehrcode immer True
BOOL TScan::New( void )
{
	 //! zuruecksetzen der akt. Kurve auf seine Initial.Werte
	 MainCurve->New();

	 //! ruecksetzen von Parametern + loeschen des Fensterinhalt + neuen
	 //! Fenstertitel
	 return TPlotData::New();
};


//! test ob Fenster geschlossen werden kann
//! -test ob Messung aktiv, wenn ja, dann zuerst Messung unterbrechen
//! -test ob geaenderte Daten, wenn ja, dann Speicher-Anfrage
//! Rueckkehrcode False wenn kein Fenster goeffnet war sonst immer True
//! wahrscheinlich ueberfluessig (wird geerbt)
BOOL TScan::CanClose( void )
{
    if ( !TMDIWindow::CanClose() ) return FALSE;
    return TRUE;
};


//! Darstellen des StepScan-Fenster
void TScan::Create( HWND hwnd )
{
    RECT rc;

    hWndChild = hwnd;
	 //! ScanFenster als Kindfenster + sein Handle
	 Main.hScanWindow = hwnd;
	 Main.ScanWindow = this;
    //! koordinaten des stepscanfenster,Arbeitsverzeichnis aus dem IniFile holen
	 //! .crv als Datei endung festlegen
    rc.left = GetPrivateProfileInt( "Scan", "xo", 500, GetCFile() );
    rc.top = GetPrivateProfileInt( "Scan", "yo", 400, GetCFile() );
	 rc.right = rc.left + GetPrivateProfileInt( "Scan", "dx", 170, GetCFile() );
	 rc.bottom = rc.top + GetPrivateProfileInt( "Scan", "dy", 50, GetCFile() );
    strcpy( szExtension, "crv" );
    strcpy( szFilter, "Scan Standard(*.crv)|*.crv|" );
    GetPrivateProfileString( "Scan", "DataPath", "c:\\", szDataPath, _MAX_PATH,
									  GetCFile() );
    if ( szDataPath[ strlen( szDataPath ) - 1 ] != '\\' )
        strcat( szDataPath, "\\" );
	 //! neuen Fenstertitel schreiben + aktualisieren des Hauptfenstermenues
    //! unter Ausfuehren -> Messung ...
    //! passt y-Scale(Intensitaet) an aktuelle Messkurve an
	 SetTitle();
	 Delay( 5000 );
    UpdateMenu();
	 SetRanges();
	 //! setzt Fenster an entsprechende Position
    SetWindowPos( hWndChild, NULL, rc.left, rc.top, rc.right - rc.left,
						rc.bottom - rc.top, SWP_NOZORDER );
};


//! setzt Titel des ScanFensters
//! Rueckkehrcode immer True
BOOL TScan::SetTitle()
{
    char aTitle[ MaxString ];

	 //! setzt aTitle
	 strcpy( aTitle, "LineScan:" );
	 //! haengt "<untitled.crv>" bei neuer Datei , sonst FileName an
    //! und schreibt ihn ins Fenster
	 if ( bIsNewFile )
        strcat( aTitle, "<untitled.crv>" );
    else
		  strcat( aTitle, FileName );
    SetWindowText( hWndChild, aTitle );
	 return TRUE;
};


//! setzt x-achse von startwinkel -> endwinkel (default 0.01,100)
//! setzt y-achse auf min -> max intensitaet siehe Dlg.box 'Displayoptions'
//! (default 1E1,1E5)
void TScan::SetRanges( void )
{
    TPlotData::SetRanges();
	 CoorSys.xMin = dArgumentMin;
	 CoorSys.xMax = dArgumentMax;
};


//! behandelt die Kommandos 'Einstellungen StepScan' &
//! 'Einstellungen ContinuousScan' des Kindfenster-menue ;
//! aufruf aus m_main.cpp DoCommandsChild()
void TScan::InitializeDlg( WPARAM task, LPARAM )
{
    TModalDlg * dlg;

	 switch ( task )
    {
		  //! Aufruf der Dialogbox 'Einstellungen StepScan'
	 case cm_SetupStepScan:
		  dlg = ( TSetupStepScan* ) new TSetupStepScan( this );
        //! zeichnet DialogBox (in dlg_tpl.cpp)
		  dlg->ExecuteDialog( hWndChild );
        delete dlg;
        break;
		  //! Aufruf der Dialogbox 'Einstellungen ContinuousScan'
    case cm_SetupContinuousScan:
        dlg = ( TSetupContinuousScan* ) new TSetupContinuousScan( this );
		  //! zeichnet DialogBox (in dlg_tpl.cpp)
        dlg->ExecuteDialog( hWndChild );
        delete dlg;
		  break;
	 }
	 //! SetRanges hier wohl ueberfluessig
	 SetRanges();
    //! Scanstart ist erlaubt (param. gueltig)
    bScanSetupOk = TRUE;
	 //! fenster neuzeichnen
	 UpdateWnd( 0 );
};


//! wird aufgerufen aus m_main.cpp bei cm_InitializeScan
//! startet den Scanvorgang
void TScan::InitializeTask( WPARAM, LPARAM )
{
   //! gibt Vorbereitungsschritt an in dem sich kont. Scan befindet
   static int nContStep=1;//! neu cont
   static double dStartPos;//! neu cont
   static double dAccelerationDistance = 0.0;//! neu cont
   static float fAccelerationTime =0.0;//! neu cont
	 float fdummy1,fdummy2,fdummy3;//! neu cont
   static int nAreaNumber;//! neu cont
   static HCURSOR hCursor;//! neu cont

	 /*double distance;*/
#ifdef GermanVersion
	 char HeadLine[] = "Start Scan";
#else
	 char HeadLine[] = "Starting Scan";
#endif
	 char fmt[ MaxString ];
	 char buf[ MaxString ];

	//! FIX Fehler 15
	if (bMonitorUsed)
	 {
			Monitor->MeasureStop();
			Monitor->SetHost( hWndChild );
			Monitor->SetExposureValues( 0.8*fMaxTime, dwMaxCounts, fFailure );
	 }

	 //! abhaengig vom eingestellten ScanTyp
	 switch ( eScanType )
	 {
		  //! standard scan starten
	 case StandardScan:
		  //! setzt geschwindigkeit des akt. motors auf 1000? warum!
		  mSetValue( Speed, 1000.0 );
		  //! ? nicht weiter verfolgt
		  mSetCorrectionState( TRUE );
		  // Motor initialisieren
		  //! Motor einstellen
		  mlSetAxis( nMotor );
		  sprintf( fmt, szMsgLine101, mGetAxisName(), mGetDF(), mGetDF() );
		  sprintf( buf, fmt, dArgumentMin, dArgumentMax );
		  //! sicherheitsabfrage, ob scan wirklich starten
		  if ( IDNO == MessageBox( GetFocus(), buf, HeadLine, MBASK ) )
				return ;
		  //! entfernt alle wm_Timer nachrichten aus warteschlange und setzt
		  //! Detektor auf inaktiv
		  Device->MeasureStop();
		  //! gibt die Werte Zeit,Impulse und Fehler an Detektor weiter
		  Device->SetExposureValues( fMaxTime, dwMaxCounts, fFailure );
		  //! FIX Fehler 70
		  MainCurve->New();
		  //! abfrage des Dateinamens, unter dem die Kurve bei Staendig Sichern
		  //! oder bei Bei Beenden speichern abgelegt werden soll
		  //! FIX Fehler 5
        if ( bSaveContinuous || bSaveOnReady )
            SaveFile( SaveWithNewName );
        //! ? ruecksetzen aller Steering-kommandos und Events
		  Steering.Reset();
        //! ? setzen des eingestellten Motors,Detektors und Kontrollfenster
		  Steering.StartUp( hWndChild, nMotor, Device->GetId() );
		  //! alt // Scan starten
		  //! Darstellungsoptionen fuer Scan setzen
        Steering.Visualising( 1, 0, 0, 0, 0, 0 );
        //! starten des standardscan
		  strcpy( buf, "" );
		  Steering.StartCmdExecution( Scan, ForScan, 0, buf, GetWndHandle() );
        break;

        //! Omega2ThetaScan starten
    case Omega2ThetaScan:
		  // Motor initialisieren
		  //! Motor einstellen
		  mlSetAxis( nMotor );
		  //! setzt geschwindigkeit des akt. motors auf 1000? warum!
		  mSetValue( Speed, 1000 );
		  //! ? von uns nicht weiter verfolgt
		  mSetCorrectionState( TRUE );
		  // Sensoren initialisieren
		  sprintf( fmt, szMsgLine102, mGetDF(), mGetDF() );
		  sprintf( buf, fmt, dArgumentMin, dArgumentMax );
		  //! sicherheitsabfrage, ob scan wirklich starten
		  if ( IDNO == MessageBox( GetFocus(), buf, HeadLine, MBASK ) )
				return ;
		  //! entfernt alle wm_Timer nachrichten aus warteschlange und setzt
		  //! Detektor auf inaktiv
		  Device->MeasureStop();
		  //! gibt die Werte Zeit,Impulse und Fehler an Detektor weiter
		  Device->SetExposureValues( fMaxTime, dwMaxCounts, fFailure );
		  //! ? setzen des eingestellten Motors,Detektors und Kontrollfenster
		  Steering.Reset();
		  //! abfrage des Dateinamens, unter dem die Kurve bei Staendig Sichern
		  //! oder bei Bei Beenden speichern abgelegt werden soll (fehler)
		  if ( bSaveContinuous || bSaveOnReady )
				SaveFile( SaveWithNewName );
		  //! ? setzen des eingestellten Motors,Detektors und Kontrollfenster
		  Steering.StartUp( hWndChild, nMotor, Device->GetId() );
		  //! alt // Scan starten
		  //! Darstellungsoptionen fuer Scan setzen
		  Steering.Visualising( 1, 0, 0, 0, 0, 0 );
		  //! starten des Omega2ThetaScan
		  strcpy( buf, "" );
		  Steering.StartCmdExecution( Scan, ForScan, Omega2ThetaScan, buf,
												GetWndHandle() );
		  break;

	 //! ContinuousScan starten
	 case ContinuousScan:
		//! neuen scan starten (auch nach abgebrochenem Scan)
		if(!bMeasurementActive||bInterrupted)
		 nContStep=1;
		switch(nContStep){
		//! start eines neuen Scan
		//! savedialog+scanstart meldung
		case 1:
			//! mit hoher Geschwindigkeit zur Startpos.
			mlSetAxis( nMotor );
			mSetValue(Speed, 1000.0);
				 sprintf( fmt, szMsgLine104, mGetAxisName(), mGetDF(), mGetDF() );
				 sprintf( buf, fmt, dArgumentMin, dArgumentMax );
				 //! sicherheitsabfrage, ob scan wirklich starten
				 if ( IDNO == MessageBox( GetFocus(), buf, HeadLine, MBASK ) )
						 return ;
			 //! speicherdialog
				 if ( bSaveOnReady )
						 SaveFile( SaveWithNewName );
				 //! loescht akt. Kurve
				 New();
			//! Beschleunigungs- bzw. Bremsweg und -zeit berechnen
         //! vorerst auskomment. da die Ini-File-Param. fehlerhaft sind
/*       fAccelerationTime = fabs(dSpeed / mGetValue( Acceleration ));
			dAccelerationDistance = fabs(0.5 * mGetValue( Acceleration ) *
											(fAccelerationTime * fAccelerationTime));*/
			//! merken der Motorposition vor Scanstart (spaeter dahin zurueck)
				 mlGetDistance(nMotor,Steering.dStartPoint);
			//! noch vorlauf(Beschleunigungsweg) einrechnen
				 dStartPos = dArgumentMin - dAccelerationDistance ;
			//! Anzahl der zu messenden Bereiche
				 nAreaNumber = nCollectionAmount;
				 //! Zeiger, dass Messung aktiv ist, setzen
				 bMeasurementActive = TRUE;
			//! schritt abgeschlossen
				 nContStep++;
#ifdef GermanVersion
				 SetInfo("Anfahren der Startposition");
#else
				 SetInfo("Move to Startposition");
#endif
		//! motor + detektor einstellen + anfahren der startposition
		case 2:
					//! setzen des ausgewaehlten Detektor und Motor
					lpDList->SetDevice( Device->GetId() );
			 //! Scanfenster dem Detektor bekannt machen (fuer benachrichtigung)
				  Device->SetEventHost(GetWndHandle());
					//! entfernt alle wm_Timer nachrichten aus warteschlange und setzt
					//! Detektor auf inaktiv
					Device->MeasureStop();
				  //! gibt die Werte Zeit,Impulse und Fehler an Detektor weiter
				  Device->SetExposureValues( fMaxTime, dwMaxCounts, fFailure );
			 //! eventuell laufende kommandos loeschen
				  Steering.Reset();
			 //! Startposition anfahren
					mlMoveToDistance(nMotor, dStartPos );
			 //! Fenster neuzeichnen und wait-Cursor
			 UpdateWnd( O_Flush );
			hCursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
			 //! warteschleife fuer erreichen der startpos. initiieren
			 PostMessage( GetWndHandle(), WM_COMMAND, cm_InitializeLineScan , 0 );
			 nContStep++;
				 break;

		//! warten bis startpositionerreicht und anschliessend bewegung zur endpos.
		//! starten
		case 3:
				 if(!mlIsMoveFinish(nMotor))
						 PostMessage( GetFrameHandle(), WM_COMMAND, cm_InitializeLineScan , 0 );
				 else
				  {
			  /*double distance;
			  mlGetDistance(nMotor,distance);
					 sprintf(buf," %f %d",distance,nAreaNumber);
					 MessageBox(GetFocus(),buf,"hh",MBINFO);*/
			  DelayTime(100);
			  //! normalen cursor setzen
			  SetCursor( hCursor );
			  //! setzt geschwindigkeit des akt. Motors
			  mlSetAxis(nMotor);
					 mSetValue( Speed, dSpeed );
					 //! motor startet zur angeg. Pos. + Bremsweg
					 mlMoveToDistance(nMotor, (dArgumentMax + dAccelerationDistance));
			  //! Beschleunigungszeit abwarten
			  if( fAccelerationTime >= 0.03)
				 DelayTime((int)(fAccelerationTime * 1000 - 20));
					 //! startet einen wiederkehrenden Event (jeweils nach fMaxTime) aufruf
					 //! von EventHandler() des jeweiligen Det. der waehrend des scans
					 //! CounterSetRequest und wenn fertig SteeringReady aufruft
			  Device->InitializeEvent( GetWndHandle(), nAreaNumber );
					 //! fenster neuzeichnen und Menue des Hauptfensters
					 //! (Ausfuehren->Messung ...)
					UpdateWnd( 0 );
					 UpdateMenu();
					 nContStep++;
				  }
				  break;

		//! fortsetzen eines unterbrochenen Scans
		case 4:
			  //! endwert des letzen gemessenen bereiches ermitteln
				  MainCurve->SetPP(MainCurve->GetPNumber());
				  MainCurve->PGet(fdummy1,fdummy2,fdummy3);
			  //! Beschleunigungsweg einrechnen
				  dStartPos = (double)fdummy3 - dAccelerationDistance;
				  MainCurve->BackStep();
			  //! verbleibende Anzahl von Bereichen ermitteln
				  nAreaNumber = nCollectionAmount - MainCurve->GetPNumber();
			  //! bei case 2 weitermachen
				  nContStep = 2;
					 PostMessage( GetWndHandle(), WM_COMMAND, cm_InitializeLineScan , 0 );
#ifdef GermanVersion
					SetInfo("Anfahren der letzten Position");
#else
					SetInfo("Move to last position");
#endif

			  break;
		}//! end switch nContStep
		  return ;
	 }
};

//********* Schnittstellen fuer Ablaufsteuerung *******************************

//! behandelt eigentlichen Scanablauf
//! aufruf aus m_main.cpp wenn cm_CounterSet
void TScan::CounterSetRequest( LPARAM lParam)
{
	 float x, y;
	 //! FIX Fehler 15
	 static float z = 0.0;
	//! merkt sich bei kont.scan das akuelle Bereichsende
	//! (ist im naechsten durchgang bereichsanfang)
	static float fLeft;
	// double dDistance;

	 // Funktion behandelt Meldung cm_CounterSet
	 //! wenn Messung unterbrochen oder keine Messung aktiv dann abbrechen
	 if ( bInterrupted )
		  return ;
	 if ( !bMeasurementActive )
		  return ;
	 //! (Kurve wurde geaendert) setzen
	 bFileChanged = TRUE;
	 //! abhaengig von akt. ScanTyp
	 switch ( eScanType )
	 {
		  //! bei StandardScan
	 case StandardScan:
		  //! wenn Monitoring dann holen der Intensitaet von diesem Detektor
		  //! und ablegen dieses Wertes z (in steering) sonst z=0 setzen
		  if ( bMonitorUsed )
		  { //! FIX Fehler 15
			if ( lParam == Monitor->GetId() )
				{
		  // normalize signal
				Monitor->GetData( z );
				Steering.SetNorm( z );
		  return;
		  }
		  }
		  else
				z = 0.0;
		  //! wenn motor auf position fuer eine Messung dann motorpos. in x ,
		  //! Detektorintensitaet in y ,tripel(x,y,z) an Kurve anhaengen und neuen
		  //! Wert darst.
		  if ( Steering.IsPositionValid() )
		  {
				// take new data
				x = mlGetValue( nMotor, Distance );
				Device->GetData( y );
				MainCurve->PAdd( x, y, z );
				UpdateWnd( O_PaintPoint ); // update data window
				//! wenn Staendig sichern eingestellt wurde dann cm_UpdateFile senden
				if ( bSaveContinuous ) // store actual value
					 SendMessage( hWndChild, WM_COMMAND, cm_UpdateFile, 0 );
		  }
		  //! sendet wieder cm_CounterSet ab
		  Device->UpdateDisplay();
		  //! ? wenn monitor eingest. dann normieren der Detektorintensitaet mit
		  //! der Monitorint. + naechste pos. anfahren
		  Steering.DeviceRequest();
		  break;

		  //! bei Omega2ThetaScan
	 case Omega2ThetaScan:
		  //! wenn Monitoring dann holen der Intensitaet von diesem Detektor
		  //! und ablegen dieses Wertes z (in steering) sonst z=0 setzen
		  if ( bMonitorUsed )
		  { //! FIX Fehler 15
				if ( lParam == Monitor->GetId() )
				{
		  // normalize signal
				Monitor->GetData( z );
				Steering.SetNorm( z );
		  return;
		  }
		}
		  else
				z = 0.0;
		  //! wenn motor auf position fuer eine Messung dann Omegamotorpos. in x,
		  //! Detektor-intensitaet in y und Thetamotorpos. in z ,
		  //! tripel(x,y,z) an Kurve anhaengen und neuen Wert darst.
		  if ( Steering.IsPositionValid() )
		  {
				// take new data
				x = mlGetValue( nMotor, Distance );
				z = mlGetValue( mlGetIdByName( Theta ), Distance );
				Device->GetData( y );
				MainCurve->PAdd( x, y, z );
				UpdateWnd( O_PaintPoint ); // update data window
				//! wenn Staendig sichern eingestellt wurde dann cm_UpdateFile senden
				if ( bSaveContinuous ) // store actual value
					 SendMessage( hWndChild, WM_COMMAND, cm_UpdateFile, 0 );
		  }
		  //! sendet wieder cm_CounterSet ab
		  Device->UpdateDisplay();
		  //! ? wenn monitor eingest. dann normieren der Detektorintensitaet mit
		  //! der Monitorint. naechsten pos. anfahren
		  Steering.DeviceRequest();
		  break;

		  //! bei ContinuousScan
	 case ContinuousScan:
	 //! bei erstem Aufruf Bereichsanfang festlegen
		if (MainCurve->GetPNumber()<1)
		 fLeft = (float) dArgumentMin;
	 char buf[MaxString];
		//! ermittelt akt. position + ablegen in x
	 mlSetAxis(nMotor);
	 x = mGetDistanceProcess();
//		x = dDistance;
	 //! holt gemessene Intensitaet des gerade abgefahrenen Bereiches von
	 //! Detektor
	  Device->GetEventIntensity( y );
#ifdef GermanVersion
		sprintf(buf,"Bereich von %f bis %f  Intensitt %f",fLeft,x,y);
#else
		sprintf(buf,"Area from %f to %f  intensity %f",fLeft,x,y);
#endif
	 //! Statuszeile ausgeben
		SetInfo(buf);
	 //! Intensitaet ueber Bereichsmittelpunkt einzeichnen
		z = (x+fLeft)/2;
	 //! Punkt zu Kurve hinzufuegen
	  MainCurve->PAdd( z , y, x);
	 //! akt. Endpunkt ist naechster Startpunkt
		fLeft = x;
	 //! Neuen punkt ins Fenster zeichnen
	 UpdateWnd( O_PaintPoint );
	 //! test ob Motor die Endposition unerwartet frueh erreicht hat
	 //! kann vorkommen wenn die Motorparameter im ini-file nicht korrekt sind
	 //! und somit der Motor schneller faehrt, als er es laut Speed sollte
	 if (mlIsMoveFinish(nMotor))
		{
	  //! Detektor anhalten
	  Device->KillEvent();
	  //! Scan beenden
	  PostMessage( GetWndHandle(), WM_COMMAND, cm_SteeringReady , 0 );
	 }
	 break;
	 }
};


//! wird augerufen nachdem Scan abgeschlossen wurde
//! aus m_main.cpp bei cm_SteeringReady
void TScan::SteeringReady( LPARAM lParam )
{
	 char buf[ MaxString ];

	 // Funktion behandelt Meldung cm_SteeringReady
	 //! Messung als beendet erklaeren
	 bMeasurementActive = FALSE;
	 //! FIX Fehler 78
	 UpdateMenu();
	 //! abhaengig von ScanTyp
	 switch ( eScanType )
	 {
		  //! standard u. Omega2Theta
	 case StandardScan:
	 case Omega2ThetaScan:
		  // Step-Scan wurde ausgefuehrt
		  switch ( HIWORD( lParam ) )
		  {
				//! wenn fehler
		  case R_Failure:
				sprintf( buf, szMsgLine105, LOWORD( lParam ));
				MessageBox( hWndChild, buf, szMsgFailureScan, MB_OK | MB_ICONSTOP );
				break;
				//! sonst
		  default:
				//! bei eingestelltem Staendig sichern, Headerinfo aktualisieren
				//! FIX Fehler 6
				if ( bSaveContinuous )
					 {
					 // Header aktualisieren
					 SaveMeasurementInfo( 1 ); // 1 means update file header
					 bFileChanged = FALSE;
					 }
				//! bei eingest. Bei Beenden speichern Kurve+ Header speichern
				//! (Fehler)
				if ( bSaveOnReady )
					 if ( SaveFile( NoAskForSave ) )
						  sprintf( buf, szMsgLine106 );
					 else
						  sprintf( buf, szMsgLine107 );
				//! FIX Fehler 76
				else if( bSaveContinuous )
						  sprintf( buf, szMsgLine106 );
					  else
						  sprintf( buf, szMsgLine113 );
				MessageBox( hWndChild, buf, szMessageScan, MBINFO );
		  }
		  //! ? von uns nicht weiter verfolgt
		  mSetCorrectionState( FALSE );
		  //! entfernt alle wm_Timer nachrichten aus warteschlange und setzt
		  //! Detektor auf inaktiv
		  Device->MeasureStop();
		  //! ? Parameter zuruecksetzen
		  Device->PopSettings();
		  //! kontrollfenster auf NULL setzen
		  Device->SetHost( NULL );
		  //! setzt timer wieder auf alten fExposureTime(Messzeit)
		  Device->MeasureStart();
		  break;

		  //! bei ContinuousScan
	 case ContinuousScan:
	  //! test ob Zielposition noch nicht erreicht
	  //! kann vorkommen, wenn der Motor langsamer faehrt, als er es laut speed
	  //! duerfte (Ursache fehlerhafte ini-parameter des motors)
	  if(!mlIsMoveFinish(nMotor))
		{
		 //! weitere 10 Bereiche messen (hoechstens)
		 bMeasurementActive=TRUE;
		 Device->InitializeEvent( GetWndHandle(), 10 );
		 break;
		}
	  //! messung als beendet kennzeichnen
		 bMeasurementActive=FALSE;
		 //! siehe m_layer.h :-(
	  //! motor sofort stoppen
		 mStopDrive( TRUE );
			//! Detektor-Parameter zuruecksetzen
		 Device->PopSettings();
		 //! setzt timer wieder auf alten fExposureTime(Messzeit) + Fenster neuz.
		 Device->MeasureStart();
		 UpdateWnd( 0 );
		 //! Motor zurueck auf position vor scanstart fahren
		 mlSetAxis(nMotor);
		 mSetValue(Speed,1000.0);
		 mlMoveToDistance(nMotor,Steering.dStartPoint);
	  //! in abhaenigkeit von speicheroption Meldung ausgeben
		 if (bSaveOnReady)
					 if ( SaveFile( NoAskForSave ) )
						  sprintf( buf, szMsgLine106 );
					 else
						  sprintf( buf, szMsgLine107 );
		 else
			  sprintf( buf, szMsgLine113 );

			MessageBox( hWndChild, buf, szMessageScan, MBINFO );
		 break;
	 }
};


//! aktive Messung unterbrechen und fortsetzen ueber Menue oder esc-taste
//! (aufruf von m_main.cpp DoCommandsChild())
void TScan::Interrupt()
{
	 //! in Abhaengigkeit von Art des Scan
	 switch ( eScanType )
	 {
	 case StandardScan:
	 case Omega2ThetaScan:
		  //! bInterrupted umkehren wenn Messung aktiv ist
		  TMDIWindow::Interrupt();
		  //! Messung unterbrechen
		  if ( bInterrupted )
		  {
				Steering.ToggleInterrupt();
				mSetCorrectionState( FALSE );
#ifdef GermanVersion
				SetInfo( "Messung wurde unterbrochen !" );
#else
				SetInfo( "The Measurement was interrupted !" );
#endif
		  }
		  //! Messung fortsetzen
		  if ( !bInterrupted && bMeasurementActive )
		  {
				mSetCorrectionState( TRUE );
				Steering.ToggleInterrupt();
		  }
		  break;

	//! kont. scan
	 case ContinuousScan:
	 //! messung unterbrechen/fortsetzen (menuepunkt aktualisieren)
    TMDIWindow::Interrupt();
		//! Messung unterbrechen
		if (bInterrupted )
		{
		  //! motor anhalten
		  mStopDrive( TRUE );
		  //! Detekor anhalten !!!
		  Device->KillEvent();
		  nScanTask = 0;
      //! statuszeilenmeldung
#ifdef GermanVersion
			SetInfo( "Messung wurde unterbrochen !" );
#else
			SetInfo( "The Measurement was interrupted !" );
#endif
		}

		  //! Messung fortsetzen
		  if ( !bInterrupted && bMeasurementActive )
		  {
        //! wiederaufnehmen des kont.scan erfolgt in InitializeTask unter case 4
		    PostMessage( GetWndHandle(), WM_COMMAND, cm_InitializeLineScan , 0 );
		  }
		  break;
	 }
};


//******************* Read/Write **********************************************

//! laden der Messungsinfos aus einer .crv bzw. .bk/.dtn datei
//! wird von TScan::LoadOldData() in m_scan.cpp aufgerufen
//! hFile ist Filehandle der Messdatei
//! Rueckkehrcode False wenn Datei zu kurz, [HEADER] nicht vorhanden oder
//! Filetyp ungleich 1 ist
//! true sonst
BOOL TScan::LoadMeasurementInfo( HFILE hFile )
{
	 char header[ 2048 ];
	 UINT nReadCnt;
	 char *token, *info, *keyword;
	 BOOL retval = FALSE;

	 // Header-Marke suchen
	 //! liest ersten 2048 bytes aus Datei (falls soviele exist.)
	 nReadCnt = _lread( hFile, ( LPSTR ) header, 2048 );
	 //! wenn datei kleiner als 100 Byte dann abbruch mit Return false
	 //! achtung Fehler bei kurzen .bk-Files
	 if ( nReadCnt < 100 )
		  goto Exit; // File korrupt
	 token = strtok( header, " \r\n" );
#ifdef GermanVersion
	 strcpy(abzisse,"Scanachse ???");
#else
	 strcpy(abzisse,"Scanaxis ???");
#endif
	 //! suchen nach [HEADER] eintrag
	 do
	 {
		  if ( strstr( token, "[Header]" ) )
				break;
		  token = strtok( NULL, " \r\n" );
		  if ( !token )
				goto Exit; // Kein Header enthalten
	 }


	 while ( 1 );
   //! defaulttype der scanart festlegen
   eScanType = StandardScan;
	 // Header-Informationen auswerten
	 //! einige Headerparam. in Nutzereinstellungen uebernehmen
	 while ( 1 )
	 {
		  keyword = strtok( NULL, " =\n\r" );
		  info = strtok( NULL, " =\n\r" );
		  if ( !strcmp( "Date", keyword ) ||
					 !strcmp( "Time", keyword ) ||
					 !strcmp( "HV", keyword ) ) continue;
		  if ( !strcmp( "User", keyword ) )
		  {
				strcpy( Main.User, info );
				continue;
		  }
		  if ( !strcmp( "Target", keyword ) )
		  {
				strcpy( Main.Target, info );
				continue;
		  }
		  if ( !strcmp( "Orientation", keyword ) )
		  {
				SetHKL( Main.Orientation, info );
				continue;
		  }
		  if ( !strcmp( "Reflection", keyword ) )
		  {
				SetHKL( Main.Reflection, info );
				continue;
		  }
		  if ( !strcmp( "WaveLength", keyword ) )
		  {
				Main.WaveLength = atof( info );
				continue;
		  }
		  if ( !strcmp( "ArgumentMin", keyword ) )
		  {
				dArgumentMin = atof( info );
				continue;
		  }
		  if ( !strcmp( "ArgumentMax", keyword ) )
		  {
				dArgumentMax = atof( info );
				continue;
		  }
		  if ( !strcmp( "ArgumentWidth", keyword ) )
		  {
				dArgumentWidth = atof( info );
				continue;
		  }
		  if ( !strcmp( "Scanaxis", keyword ) )
		  {
				strcpy(abzisse,info);
				continue;
		  }
		  if ( !strcmp( "TimePerScan", keyword ) )
		  {
				fMaxTime = atof( info );
				continue;
		  }
        if ( !strcmp( keyword, "FileType" ) )
        {   //! Standard-scan
            if (( *info == '1' )|| !strcmp( info, "Standard" ))
            {
                eSaveFormat = StandardFile;
                TPlotData::SetFileType(eSaveFormat);
            }
            //! bkFile Format eingefuehrt
            else if (( *info == '2' )||!strcmp( info, "Comparison" ))
            {
                eSaveFormat = bkFile;
					 TPlotData::SetFileType(eSaveFormat);
				}
            //! dtnFile Format eingefuehrt
				else if ( *info == '3'|| !strcmp( info, "Aquisition" ) )
            {
                eSaveFormat = dtnFile;
					 TPlotData::SetFileType(eSaveFormat);
				}
        else if( !strcmp( info, "Omega2Theta" ))
            {   //! Omega2Thetascan
                eScanType = Omega2ThetaScan;
                eSaveFormat = StandardFile;
                TPlotData::SetFileType(eSaveFormat);
            }
        else if( !strcmp( info, "Continuous" ))
            {   //! kont.scan
                eScanType = ContinuousScan;
                eSaveFormat = StandardFile;
                TPlotData::SetFileType(eSaveFormat);
            }
        else
            {
                TPlotData::SetFileType(0);
                goto Exit;
            } // Falsches File-Format
				continue;
		  }
        if ( strstr( keyword, "[Data]" ) ) break;
        if ( strstr( info, "[Data]" ) ) break;
    }
    // check infos
	 //! Header war korrekt (=> Return true)
    retval = TRUE;
Exit:
    return retval;
};


//! Speichern bzw. Aktualisieren der Headerinformation
//! UpdateHeader ==0 => neu erstellen
//! ==1 => aktualisieren
//! Rueckkehrcode False wenn Fehler bei speichern sonst true
BOOL TScan::SaveMeasurementInfo( BOOL UpdateHeader )
{
	 //! FIX Fehler 11
	 int hFile;
	 OFSTRUCT of;
	 UINT nSize;
	 char format[ MaxString ];
	 char buf[ 2 * MaxString ], buf2[ 20 ], buf3[ 20 ];
	 char *data;
	 const int dataoffset = 1000;
//	 struct date d;
//	 struct time t;
     SYSTEMTIME st;

	 //! UpdateHeader ==0 => neu erstellen
	 //! ==1 => aktualisieren
	 //! FIX Fehler 11
	 if ( UpdateHeader )
		  hFile=OpenFile(FileName,&of,OF_WRITE);
	 else
		  hFile=OpenFile(FileName,&of,OF_CREATE);
	 //! Fehler bei oeffnen der Datei => abbruch
	 //! FIX Fehler 11
	 if(-1==hFile)
		  return FALSE;
	 //! akt. Uhrzeit + Datum holen
	 GetLocalTime( &st );
	 //! Headerinformationen in String ablegen
	 data = new char[ dataoffset + 1 ];
	 strcpy( format, "Comment=%s" );
	 sprintf( buf, format, Main.Comment );
	 strcpy( data, buf );
	 strcat( data, EOL );

	 strcat( data, "[Header]" );
	 strcat( data, EOL );
	 strcpy( format, "User=%s Date=%02i.%02i.%i Time=%2d:%02d:%02d DataOffset=%d"
			 );
	 sprintf( buf, format, Main.User, (int)st.wDay, (int)st.wMonth, (int)st.wYear, (int)st.wHour, \
				 (int)st.wMinute, (int)st.wSecond, dataoffset );
	 strcat( data, buf );
	 strcat( data, EOL );

   //! bezeichnerstring der linescanart ermitteln
   switch(eScanType){
   case ContinuousScan:strcpy(buf2,"Continuous");
                       break;
   case Omega2ThetaScan:strcpy(buf2,"Omega2Theta");
                       break;
   case StandardScan:
   default:strcpy(buf2,"Standard");
   }
	 strcpy( format, "Point_Number=%d FileType=%s" );
	 sprintf( buf, format, MainCurve->GetPNumber(), buf2 );
	 strcat( data, buf );
	 strcat( data, EOL );

	 strcpy( format, "Target=%s Reflection=%s Orientation=%s" );
	 GetHKL( Main.Reflection, buf2 );
	 GetHKL( Main.Orientation, buf3 );
	 sprintf( buf, format, Main.Target, buf2, buf3 );
	 strcat( data, buf );
	 strcat( data, EOL );

	 mlSetAxis( nMotor );
	 sprintf( format, "ArgumentMin=%s ArgumentWidth=%s ArgumentMax=%s", mGetDF(),
				 mGetSF(), mGetDF() );
	 sprintf( buf, format, dArgumentMin, dArgumentWidth, dArgumentMax );
	 sprintf(format," Scanaxis=%s",mGetAxisName());
	 strcat(buf,format);
	 strcat( data, buf );
	 strcat( data, EOL );

	 strcpy( format, "WaveLength=%.3f Current=%d HV=%d" );
	 sprintf( buf, format, Main.WaveLength, Main.Current, Main.Voltage );
	 strcat( data, buf );
	 strcat( data, EOL );

	 strcpy( format, "TimePerScan=%.2f" );
	 sprintf( buf, format, fMaxTime );
	 strcat( data, buf );

	 nSize = strlen( data );
	 //! string am ende der Info. bis zum Wert dataoffset(=1000) mit Leerzeichen
	 //! auffuellen incl. mit [DATA] abschliessen
	 for ( ; nSize < dataoffset - 10; nSize++ )
		  data[ nSize ] = ' ';
	 data[ nSize ] = 0x0;
	 strcat( data, EOL );
	 strcat( data, "[Data]" );
	 strcat( data, EOL );
    //! schreiben der Headerinfo. in die Datei + schliessen der Datei
    //! FIX Fehler 11
	 _lwrite(hFile,data,strlen(data));
    _lclose(hFile);
    delete[] data;
	 return TRUE;
};


//! speichern einer .crv Datei
//! ask== NoAskForSave(0x9900) => speichert unter namen aus FileName ohne
//! Abfrage
//! == SaveWithNewName(0x9901) => speichert unter Namen, der im Dialogbox
//! erst noch einzugeben ist
//! Rueckkehrcode False wenn Fehler bei anlegen der Datei oder bei speichern
//! der Headerinfo. sonst true
BOOL TScan::SaveFile( int ask )
{
	 char fmt[ 30 ], buf[ MaxString ];
	 FILE* hFile;
	 HCURSOR hCursor;
	 float x, y, z, x2, y2, z2;
	 //! nicht von diffr.gruppe auskommentiert
	 //! int nNumber = 0;

	 //! anlegen der Datei (event. mit eingabe des Dateinamen)
	 if ( !TMDIWindow::SaveFile( ask ) )
		  return FALSE;
	 //! ueberschreiben der Datei mit Headerinfo.
	 if ( !SaveMeasurementInfo( 0 ) )
	 {
		  MessageBox( GetFocus(), szMsgLine108, szMessageScan, MBINFO );
		  return FALSE;
	 }
	 //! oeffnen der datei + mauszeiger beschaeftigtsymbol
	 hFile = fopen( FileName, "r+" );
	 hCursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
	 //! auf ersten Messpunkt der Kurve gehen
	 MainCurve->SetPP( 0 );
	 //! setzt Dateizeiger auf ende der Datei
	 fseek( hFile, 0, SEEK_END );
	 sprintf( fmt, "%s %s %s\r\n", mGetSF(), "%.4f", "%.4f" );
	 MainCurve->FastOpen();
   //! Bereichstartpunkt fuer ersten bereich festlegen
   y2=dArgumentMin;
	 //! holt einzelne tripel aus Kurve + fuegt sie an datei an
	 while ( MainCurve->FastPGet( x, y, z ) )
	 {
      //! bedeutung der kurvenwerte bei kont.scan anders
      if (eScanType == ContinuousScan)
        {
        //! zuordnung kont.Format
        //! Bereichsanfang,Bereichsende,Intensitaet
        x2=y2;
        y2=z;
        z2=y;
        }
      else
        {
        //! zuordnung normales Format
        //! motorpos,Intens.,sonderinfo(Monitorint. o. thetapos bei O2T-scan)
        x2=x;
        y2=y;
        z2=z;
        }
		  sprintf( buf, fmt, x2, y2, z2 );
		  fwrite( buf, strlen( buf ), 1, hFile );
	 }
	 //! nNumber sollte evtl. zur Fehlerbehandlung verwendet werden
	 //! nicht von diffr.gruppe auskommentiert
	 //! nNumber = fclose(hFile);

	 //! schliessen der Datei + setzen des alten Mauszeigers + schliessen der
	 //! Kurve
	 fclose( hFile );
	 SetCursor( hCursor );
	 MainCurve->FastClose();
	 //! variabl. setzen, um fenster ohne weitere Speicheranfrage verlassen zu
	 //! koennen
	 bFileChanged = FALSE;
	 return TRUE;
};


//! haengt aktuelles tripel der Messkurve an Datei mit FileName an
//! aufruf nur bei kontinuierlichem Speichern
//! Rueckkehrcode False wenn fehler bei oeffnen der Datei sonst true
BOOL TScan::UpdateFile( void )
{
	 float x, y, z;
	 char buf[ MaxString ];
	 char fmt[ MaxString ];
	 int hFile;
	 OFSTRUCT of;

	 //! test ob neuer Dateiname (Fehler)
	 if ( bIsNewFile )
		  SaveFileAs();
	 //! datei oeffnen + test auf fehler mit Fehlermeldung
	 hFile = OpenFile( FileName, &of, OF_WRITE );
	 if ( -1 == hFile )
	 {
		  MessageBox( GetFocus(), szMsgLine109, szMsgFailureScan, MB_OK );
		  return FALSE;
	 }
	 //! aktuelles tripel Messwerte (x,y,z) aus Kurve formatiert an datei
	 //! anhaengen + datei schliessen
	 MainCurve->PGet( x, y, z );
	 sprintf( fmt, "%s %s %s\r\n", mGetSF(), "%.4f", "%.4f" );
	 sprintf( buf, fmt, x, y, z );
	 _llseek( hFile, 0, SEEK_END );
	 _lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
	 _lclose( hFile );
	 return TRUE;
};


//! liest gespeicherte Kurve (.crv/.bk)
//! ?? inputparam nicht implem.
//! Rueckkehrcode false wenn Fehler beim oeffnen der Datei, fehlerhaften
//! Headerinfo. oder keine Eintraege nach[DATA] sonst true
BOOL TScan::LoadOldData( int )
{
	 char NewFileName[ _MAX_PATH ];
	 const int LLength = 2500;
	 HCURSOR hCursor;
	 LPSTR lpBuf;
	 char buf[ MaxString ];
	 char buf2[ MaxString ];
	 float x, y, z;
	 int hFile, cnt;
	 OFSTRUCT of;
	 char dir[ _MAX_DIR ], drv[ _MAX_DRIVE ], name[ _MAX_FNAME ], ext[ _MAX_EXT ];
	 //! FIX Fehler 7
	 BOOL bReady = FALSE;

	 //! wechseln in Arbeitsverzeichniss + angeben der Filter (erlaubte
	 //! Fileextensions)
	 _chdir( szDataPath );
	 char Filter[] = "Curve Standard (*.crv)|*.crv|Compare Curve (*.bk)|*.bk|Curve Inquire Data (*.dtn)|*.dtn|";
	 strcpy( NewFileName, "" );
	 //! Aufruf der Win-api-Fkt. zum auswaehlen einer Datei aus einer Dialogbox
	 //! nach Aufruf enthaelt NewFileName den ausgew. Dateinamen(incl. Pfad) und
	 //! szDataPath den zugehoerigen Pfad + anschliessend uebernehmen als neuen
	 //! FileName
	 FileOpen( szMsgLine110, Filter, NewFileName, szDataPath );
	 //! FIX Fehler 14
	 if((strcmp(strupr(&(NewFileName[strlen(NewFileName)-3])),"CRV"))&&
		 (strcmp(strupr(&(NewFileName[strlen(NewFileName)-2])),"BK"))&&
		 (strcmp(strupr(&(NewFileName[strlen(NewFileName)-3])),"DTN")))
		  return FALSE;
	 strcpy( FileName, NewFileName );
	 //! oeffnen dieser Datei zum lesen und Abbruch und Fehlermeldung falls nicht
	 //! moeglich
	 hFile = OpenFile( FileName, &of, OF_READ );
	 if ( -1 == hFile )
	 {
		  MessageBox( GetFocus(), szMsgLine111, szMsgFailureScan, MBINFO );
		  return FALSE;
	 }
	 //! setzt Wartemauszeiger + zerlegen von FileName in Pfad,Laufwerk,Name und
	 //! Endung
	 hCursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
	 _splitpath( FileName, drv, dir, name, ext );
	 sprintf( szDataPath, "%s%s", drv, dir );
	 //! laden der Headerinformation mit abbruch und Fehlermeldung bei Fehler
	 if ( !LoadMeasurementInfo( hFile ) )
	 {
		  MessageBox( GetFocus(), szMsgLine108, szMessageScan, MBINFO );
		  return FALSE;
	 }
   //! Statuszeilenmeldung festlegen
   if (eScanType==ContinuousScan)
    strcpy(buf2,szMsgLine114);
   else
    strcpy(buf2,szMsgLine112);
	 //! loeschen der aktuellen Kurve
	 MainCurve->New();
	 MainCurve->FastOpen();
	 lpBuf = new char [ LLength ];
	 //! test ob Werte hinter [DATA] folgen
	 if ( !SetFPOnData( hFile ) ) return FALSE;
	 //! zeilenweises einlesen und ablegen der Punkte in Kurve sowie Ausgabe der
	 //! Anzahl der gelesenen tripel in 30er schritten bis Ende der Datei erreicht
	 //! oder Zeile zu lang ?
	 //! FIX Fehler 7
	 for ( cnt = 0; !bReady ; cnt++ )
		  switch ( GetFileLine( hFile, lpBuf, LLength ) )
		  {
		  case R_Overflow:
				//! hier SetInfo eingebaut, damit korrekte Ausgabe der Anzahl der Punkte
				sprintf( buf, buf2, ++cnt );
				SetInfo( buf );
				bReady =TRUE;
				continue;

		  case R_EndOfFile:
				//! hier SetInfo eingebaut, damit korrekte Ausgabe der Anzahl der Punkte
				sprintf( buf, buf2, ++cnt );
				SetInfo( buf );
				bReady = TRUE;

		  default:
				if ( 3 != sscanf( lpBuf, "%f %f %f", &x, &y, &z ) ) continue;
				if ( 0 == ( cnt % 30 ) )
				{
					 sprintf( buf, buf2, cnt );
					 SetInfo( buf );
				}
        //! zu zeichnene kurve aus datei erstellen (abhaengig von Scanart)
        if(eScanType == ContinuousScan)
          {
           //! intensitaeten ueber bereichsmitte abtragen
           x = (x+y)/2;
           MainCurve->FastPAdd( x, z, y);
          }
        else
				  MainCurve->FastPAdd( x, y, z );
		  }

	 //! setzen des norm. Mauszeigers + schliessen der akt. Kurve + setzen des
	 //! x-Bereichs
	 SetCursor( hCursor );
	 //! eingefuegt fuer dtn File Achsenbeschriftung...
	 //! im dtnFile ist Omega zu Anfang immer am kleinsten und steigt dann
	 //! aber zugehoeriges Theta muss erst noch bestimmt werden...
	 if (eLoadFormat==dtnFile)
	 {
		  float xtemp,ytemp,ztemp;
		  MainCurve->SetPP(0);
		  MainCurve->FastPGet(x,y,z);
		  MainCurve->SetPP(MainCurve->GetPNumber()-1);
		  MainCurve->FastPGet(xtemp,ytemp,ztemp);
		  CoorSys.zMin=z;
		  CoorSys.zMax=ztemp;
	 }

	 MainCurve->FastClose();
   //! bei kont. scan keine anpassung des koor.systems an position der kurve
   if( eScanType != ContinuousScan)
   {
	  dArgumentMin = MainCurve->Min[ P_X ];
	  dArgumentMax = MainCurve->Max[ P_X ];
   }
	 delete[] lpBuf;
	 //! variabl. setzen, um fenster ohne weitere Speicheranfrage verlassen zu
	 //! koennen y-bereich neu festlegen + koord.system neu zeichnen
	 bIsNewFile = FALSE;
	 SetRanges();
	 UpdateWnd( 0 );
	 //! akt. Kurve wurde geladen (Fehler)
	 bOldDataLoaded = TRUE;
	 return TRUE;
};

//***************** Mausbedienung *********************************************

//! aufruf wenn rechte Maustaste gedrueckt
//! Fenstermenue an aktueller Mausposition ausgeben
//! eingabeparam. aktuelle Mauspos.low(8) x-pos
//! high(8) y-pos.
void TScan::rButtonDown( LONG lParam )
{
	 POINT pp;
	 //! dieses if eingefuegt, damit bei eingelesenem dtnfile keine Setupmenuaufruf moeglich
	 if (eSaveFormat==dtnFile)
	 {
		  EnableMenuItem(TheMenu,cm_SetupStepScan,MF_GRAYED);
		  EnableMenuItem(TheMenu,cm_InitializeScan,MF_GRAYED);
		  EnableMenuItem(TheMenu,cm_FreezeCurve,MF_GRAYED);
		  EnableMenuItem(TheMenu,cm_KillSecondCurve,MF_GRAYED);
		  EnableMenuItem(TheMenu,cm_SaveSecondCurve,MF_GRAYED);
	 }
	 else
	 {
		  EnableMenuItem(TheMenu,cm_SetupStepScan,MF_ENABLED);
      //! abhaengig von eingestellter scanart menueeintrag fuer scanstart festlegen
		  if (eScanType==ContinuousScan)
#ifdef GermanVersion
			 ModifyMenu( TheMenu, cm_InitializeScan, MF_STRING|MF_BYCOMMAND,cm_InitializeScan,
			 "kontinuierlichen &Scan starten" );
#else
			 ModifyMenu( TheMenu, cm_InitializeScan, MF_STRING|MF_BYCOMMAND,cm_InitializeScan,
			 "start Continuous&Scan" );
#endif
		  else
#ifdef GermanVersion
			 ModifyMenu( TheMenu, cm_InitializeScan, MF_STRING|MF_BYCOMMAND,cm_InitializeScan,
			 "Step&Scan starten" );
#else
			 ModifyMenu( TheMenu, cm_InitializeScan, MF_STRING|MF_BYCOMMAND,cm_InitializeScan,
			 "start Step&Scan" );
#endif
		  //! scanstart soll nur moeglich sein wenn keine Messung aktiv , akt. Messung
		  //! unterbrochen , eine Einstellungsbox aufgerufen wurde
		  //! FIX Fehler 77
		  if ( ( bMeasurementActive && !bInterrupted ) || !bScanSetupOk )
			 EnableMenuItem(TheMenu,cm_InitializeScan,MF_GRAYED);
		  else
			 EnableMenuItem(TheMenu,cm_InitializeScan,MF_ENABLED);
		//! neu fixscan
		if (1>SecondCurve->GetPNumber())
		{
			EnableMenuItem( TheMenu, cm_FreezeCurve, MF_ENABLED );
		 EnableMenuItem( TheMenu, cm_SaveSecondCurve, MF_GRAYED );
		 EnableMenuItem( TheMenu, cm_KillSecondCurve, MF_GRAYED );
//!       ModifyMenu( TheMenu, 5, MF_STRING|MF_BYPOSITION,5,"Scan" );
		}
		else
		{
		   EnableMenuItem( TheMenu, cm_FreezeCurve, MF_GRAYED );
     	 EnableMenuItem( TheMenu, cm_SaveSecondCurve, MF_ENABLED );
    	 EnableMenuItem( TheMenu, cm_KillSecondCurve, MF_ENABLED );
//!       ModifyMenu( TheMenu, 5, MF_STRING|MF_BYPOSITION,5,"fixierten Scan" );
      }
	 }

	 pp.x = LOWORD( lParam );
	 pp.y = HIWORD( lParam );
	 ClientToScreen( hWndChild, &pp );
	 //! ausgabe des menues
	 TrackPopupMenu( TheMenu, 0, pp.x, pp.y, 0, hWndChild, NULL );
};

//! scheinbar ueberfluessig nur fuer Tscan def. nicht geerbt
BOOL TScan::SaveDataBase( void )
{
	 return TRUE;
};

//*****************************************************************************
//******* Dialog zum Setzen der Scan-Parameter ********************************
//*****************************************************************************

//! konstruktor fuer Dialogeinst. StepScan (standard/Omega2Theta)
//! dabei wird zunaechst der Konstr. fuer Dialogboxen mit dem string der die
//! Resource spezifiziert aufgerufen
#ifdef GermanVersion
TSetupStepScan::TSetupStepScan( TScan* scan ) : TModalDlg( "ScanParameters" )
#else
TSetupStepScan::TSetupStepScan( TScan* scan ) : TModalDlg( "ScanParametersEng"
																					  )
#endif
{
    //! Parameter von Scanfenster uebernehmen (fehler)
    Scan = scan;
    nMotorOld = Scan->nMotor;
    eSaveFormat = Scan->eSaveFormat;
    eScanType = Scan->eScanType;
	 bSaveOnReady = Scan->bSaveOnReady;
	 dArgumentMin = Scan->dArgumentMin;
    dArgumentMax = Scan->dArgumentMax;
	 dArgumentWidth = Scan->dArgumentWidth;
    DeviceOld = Scan->Device;
    fMaxTime = Scan->fMaxTime;
	 dwMaxCounts = Scan->dwMaxCounts;
	 bMonitorUsed = Scan->bMonitorUsed;
	 MonitorOld = Scan->Monitor;
	 bSaveContinuous = Scan->bSaveContinuous;
	 strcpy( szPath, Scan->szDataPath );
/*	 if ( Scan->eScanType == ContinuousScan )
		  Scan->eScanType = StandardScan;*/
   //! akt. 2Thetawert aus Scanfenster holen
   d2ThetaStart = Scan->d2ThetaStart;

};


//#pragma argsused
//! setzt Defaultwerte in Dialogbox
//! Rueckkehrcode immer true
BOOL TSetupStepScan::Dlg_OnInit( HWND hwnd, HWND hwndCtl, LPARAM lParam )
{
	 int i = 0;

	 //! Handles der Comboboxen uebergeben + uebergeben der akt. Motor, Detekt.,
	 //! Monit.
	 hDeviceList = GetDlgItem( GetHandle(), id_ChooseDevice );
	 hMotorList = GetDlgItem( GetHandle(), id_ChooseMotor );
	 hScanTypeList = GetDlgItem( GetHandle(), id_ChooseScanType );
	 nMotor = Scan->nMotor;
	 Device = Scan->Device;
	 Monitor = Scan->Monitor;
	 //! eintragen der Comboboxauswahlelemente fuer Scantyp, Detektor und
	 //! Scanachse vorauswahl der aktiven geraete
	 ComboBox_AddString( hScanTypeList, "Standard" );
   //! Omega2Thetamodus nur bei exist. Theta erlauben
   if(mlIsAxisValid(Theta))
	 ComboBox_AddString( hScanTypeList, "Omega-2Theta" );
	 i = 0;
	 while ( i <= lpDList->LastId() )
		  ComboBox_AddString( hDeviceList, lpDList->DP( i++ ) ->Characteristic );
	 ComboBox_SelectString( hDeviceList, 0, Device->Characteristic );
	 i = -1;
	 while ( ++i < mlGetAxisNumber() )
	 {
		  mlSetAxis( i );
		  ComboBox_AddString( hMotorList, mGetAxisName() );
	 }
	 mlSetAxis( nMotor );
	 ComboBox_SelectString( hMotorList, 0, mGetAxisName() );
	 //! wenn kein Monit. vorhanden, kann der Monitor-Signal-Button nicht
	 //! aktiviert werden sonst setzen des Haekchens abhaengig von uebergeb.
	 //! Param.
	 if ( !Monitor )
		  EnableWindow( GetDlgItem( GetHandle(), id_MonitorUsed ), FALSE );
	 else
		  CheckDlgButton( GetHandle(), id_MonitorUsed, Scan->bMonitorUsed );
	 //! Aenderung Dynamische Schrittweite
	 //! aktivieren von Checkbutton und Einstellungsbox fuer Dyn. Schrittweite
    //! abhaengig von Param.
	 CheckDlgButton( GetHandle(), id_DynamicActive, Scan->bDynamicStepWidth );
	 EnableWindow( GetDlgItem( GetHandle(), cm_DynamicSetup ), Scan->bDynamicStepWidth );
	 //! abhaengig von Haekchen aktivierung des Monitorauswahlbuttons
	 if ( !IsDlgButtonChecked( GetHandle(), id_MonitorUsed ) )
		  EnableWindow( GetDlgItem( GetHandle(), cm_RotateDevice ), FALSE );
	 //! setzt dialoginhalte
	 CheckDlgButton( GetHandle(), id_SaveOnReady, Scan->bSaveOnReady );
	 CheckDlgButton( GetHandle(), id_SaveContinuous, Scan->bSaveContinuous );

	 //! wahrscheinlich ueberfluessig
	 SetFocus( GetDlgItem( GetHandle(), id_ChooseMotor ) );
	 //! wenn ScanTyp Omega2Theta dann Motorcombobox ausgrauen sonst nicht
	 switch ( eScanType )
	 {
	 case StandardScan:
		  ComboBox_SelectString( hScanTypeList, 0, "Standard" );
		  EnableWindow( GetDlgItem( GetHandle(), id_ChooseMotor ), TRUE );
      EnableWindow( GetDlgItem( GetHandle(), id_2Theta ), FALSE );
		  break;
	 case Omega2ThetaScan:
		  ComboBox_SelectString( hScanTypeList, 0, "Omega-2Theta" );
		  EnableWindow( GetDlgItem( GetHandle(), id_ChooseMotor ), FALSE );
		  break;
	 }
	 //! bewirkt Aufruf von Dlg_OnCommand mit Kommando cm_ParamSet
	 FORWARD_WM_COMMAND( hwnd, cm_ParamSet, hwndCtl, 0, SendMessage );
    return TRUE;
};


//! behandelt alle kommandos in der Dialogbox
//! id = id-Nr. des ausgewaehlten Dialogelements bzw. ein cm_...
void TSetupStepScan::Dlg_OnCommand( HWND hwnd, int id, HWND hwndCtl,
												UINT codeNotify )
{
	 int idx;
	 char buf[ MaxString ];
	 //! Aenderung Dynamische Schrittweite
	 TModalDlg * dlg;

	 //! abhaengig von dialogelement bzw. Kommando
	 switch ( id )
	 {
		  //! initialisierung ?(siehe Fehler)
	 case cm_ParamSet:
        //! setzen der zum Motor gehoerigen Einheit
        SetDlgItemText( GetHandle(), id_Unit, mGetAxisUnit() );
        //! namen oder 'kein Geraet' in Monitordevice-button schreiben
        if ( Monitor )
            SetWindowText( GetDlgItem( GetHandle(), cm_RotateDevice ),
                           Monitor->Characteristic );
		  else
				SetWindowText( GetDlgItem( GetHandle(), cm_RotateDevice ),
                           ( LPSTR ) "Kein Geraet" );
        //! focus auf Ok-button
        SetFocus( GetDlgItem( GetHandle(), IDOK ) );
		  //! alt // Bereich sollte den Motor nicht beeinflussen
        //! test auf korrekte Bezieh. zwischen Min und Max
        //! eintragen von korrekten Werten in Dialogbox
		  sprintf( buf, mGetSF(), Scan->dArgumentWidth );
        SetDlgItemText( GetHandle(), id_AngleWidth, ( LPSTR ) buf );
		  if ( Scan->dArgumentMax >= mGetValue( MaxDistance ) )
				Scan->dArgumentMax = mGetValue( MaxDistance ) - mGetValue( MinWidth );
		  sprintf( buf, mGetDF(), Scan->dArgumentMax );
        SetDlgItemText( GetHandle(), id_AngleMax, ( LPSTR ) buf );
        if ( Scan->dArgumentMin <= mGetValue( MinDistance ) )
            Scan->dArgumentMin = mGetValue( MinDistance ) + mGetValue( MinWidth );
        sprintf( buf, mGetDF(), Scan->dArgumentMin );
		  SetDlgItemText( GetHandle(), id_AngleMin, ( LPSTR ) buf );
        SetDlgItemText( GetHandle(), id_Catalog, ( LPSTR ) Scan->szDataPath );
        ComboBox_SelectString( hMotorList, 0, mGetAxisName() );
        ComboBox_SelectString( hDeviceList, 0, Device->Characteristic );
        //! FIX Fehler 8
        sprintf( buf, "%.1f", Scan->fMaxTime );
        SetDlgItemText( GetHandle(), id_MaxTime, ( LPSTR ) buf );
        sprintf( buf, "%lu", Scan->dwMaxCounts );
        SetDlgItemText( GetHandle(), id_MaxCounts, ( LPSTR ) buf );
        //! neu 2Theta
        sprintf( buf, "%f", d2ThetaStart );
        SetDlgItemText( GetHandle(), id_2Theta, ( LPSTR ) buf );

        break;

		  //! auswahl von Scan-Typ-Combobox erfolgt
	 case id_ChooseScanType:
        //! scheinbar ueberfluessig (getestet)
        switch ( eScanType )
        {
        case StandardScan:
            SendMessage( hScanTypeList, WM_SETTEXT, 0, ( LPARAM ) "Standard" );
            break;
		  case Omega2ThetaScan:
            SendMessage( hScanTypeList, WM_SETTEXT, 0, ( LPARAM ) "Omega-2Theta"
							  );
				break;
		  }
        //! test ob aenderung in Combobox
        switch ( codeNotify )
        {
            //! wenn ja => was wurde ausgewaehlt
		  case CBN_SELCHANGE:
            switch ( ComboBox_GetCurSel( hScanTypeList ) )
            {
            case 0: // StandardScan
                eScanType = StandardScan;
                ComboBox_SelectString( hScanTypeList, 0, "Standard" );
                EnableWindow( GetDlgItem( GetHandle(), id_ChooseMotor ), TRUE );
                EnableWindow( GetDlgItem( GetHandle(), id_2Theta ), FALSE );
                break;

            case 1: // Omega2ThetaScan
                eScanType = Omega2ThetaScan;
					 //! test ob auch omega und theta motoren vorhanden
					 if ( !mlIsAxisValid( Omega ) || !mlIsAxisValid( Theta ) )
                {
                    //! nicht vorhanden => standard-scan setzen + abbruch
                    eScanType = StandardScan;
                    ComboBox_SelectString( hScanTypeList, 0, "Standard" );
                    break;
					 }
					 //! motoren vorhanden => omega-motor setzen + omega2theta-scan
                //! setzen + Scan-Achsen-combobox sperren
					 nMotor = mlGetIdByName( Omega );
					 mlSetAxis( nMotor );
					 ComboBox_SelectString( hScanTypeList, 0, "Omega-2Theta" );
                EnableWindow( GetDlgItem( GetHandle(), id_ChooseMotor ), FALSE );
                EnableWindow( GetDlgItem( GetHandle(), id_2Theta ), TRUE );

            }
        }
        break;

        //! Scan-Achsen-Combobox ausgewaehlt
	 case id_ChooseMotor:
        //! test ob aenderung in combobox
        switch ( codeNotify )
        {
            //! ja => setzen des Motors
        case CBN_SELCHANGE:
            idx = ComboBox_GetCurSel( hMotorList );
            if ( ( nMotor != idx ) && ( idx != CB_ERR ) )
            {
					 mlSetAxis( idx );
					 nMotor = mlGetAxis();
            }
        //! FIX Fehler 9
        FORWARD_WM_COMMAND(GetHandle(),cm_ParamSet,0, 0, PostMessage );
        }
        break;

		  //! Detektor-combobox ausgewaehlt
    case id_ChooseDevice:
		  //! test ob aenderung in combobox
		  switch ( codeNotify )
		  {
            //! ja => setzen des Detektors
		  case CBN_SELCHANGE:
				idx = ComboBox_GetCurSel( hDeviceList );
				if ( ( Device != lpDList->DP( idx ) ) && ( idx != CB_ERR ) )
					 Device = lpDList->DP( idx );
		  }
		  break;

		  //! Monitor-button angeklickt
	 case cm_RotateDevice: // monitor select
		  //! setzen des naechsten Detektors aus der Detektorliste
		  Monitor = lpDList->DP( Monitor->GetId() + 1 );
		  SetDlgItemText( GetHandle(), cm_RotateDevice,
								( LPSTR ) Monitor->Characteristic );
		  break;

		  //! Monitor-signal-checkbox angeklickt
	 case id_MonitorUsed:
		  //! wenn keine Monit.det. existieren => abbruch
		  if ( !Monitor )
				break;
		  //! ansonsten bei Haekchen => nicht ausgrauen sonst ausgrauen des
		  //! Monitor-buttons
		  if ( IsDlgButtonChecked( GetHandle(), id_MonitorUsed ) )
				EnableWindow( GetDlgItem( GetHandle(), cm_RotateDevice ), TRUE );
		  else
				EnableWindow( GetDlgItem( GetHandle(), cm_RotateDevice ), FALSE );
		  break;

	 //! FIX Fehler 71
	 case id_SaveContinuous: CheckDlgButton(GetHandle(),id_SaveOnReady,FALSE);
										break;
	 case id_SaveOnReady:    CheckDlgButton(GetHandle(),id_SaveContinuous,FALSE);
										break;

	 //! Aenderung Dynamische Schrittweite
	 //! Start der Dialogbox 'Einstellungen Dyn. Schrittweite' bei Auswahl des
	 //! Einstellungs-Button
	 case cm_DynamicSetup:
		  {
				dlg = ( TSetupDynamicStep * ) new TSetupDynamicStep( Scan );
				dlg->ExecuteDialog( hwnd );
				delete dlg;
				break;
		  }

	 //! Aenderung Dynamische Schrittweite
	 //! bei Auswahl der Aktivieren-Checkbox automatisches Oeffnen der
	 //! Einstellungsbox fuer dyn. Schrittweite
	 case id_DynamicActive:
		  if ( IsDlgButtonChecked( GetHandle(), id_DynamicActive ) )
		  {
			EnableWindow( GetDlgItem( GetHandle(), cm_DynamicSetup ), TRUE );
			PostMessage( GetHandle(), WM_COMMAND, ( WPARAM ) cm_DynamicSetup, 0 );
		  }
		  else
				EnableWindow( GetDlgItem( GetHandle(), cm_DynamicSetup ), FALSE );
		  break;

	 //! hier werden IDOK,IDCANCEL und IDABBORT behandelt
	 default:
		  TModalDlg::Dlg_OnCommand( hwnd, id, hwndCtl, codeNotify );
	 }
};


//! realisiert test der Dialogboxinhalte auf ihre konsistenz vor verlassen der
//! Dialogbox (durch OK-Button)
//! Rueckkehrcode False wenn die Dlg.box nicht geschlossen werden kann (werte
//! inkonsistent) sonst true
BOOL TSetupStepScan::CanClose( void )
{
	 char buf[ MaxString ];
	 BOOL bFailure = FALSE;
    OFSTRUCT of;
	 float valueF;
    long valueL;
    int hfile;
    char dir[ _MAX_DIR ], drv[ _MAX_DRIVE ], name[ _MAX_FNAME ], ext[ _MAX_EXT ];

	 //! uebernehmen der Einstellungen Staendig sichern und Bei Beenden speichern
	 Scan->bSaveContinuous = IsDlgButtonChecked( GetHandle(), id_SaveContinuous );
	 Scan->bSaveOnReady = IsDlgButtonChecked( GetHandle(), id_SaveOnReady );

	 //! Aenderung Dynamische Schrittweite
	 //! uebernehmen der Einstellungen Dyn. Schrittweite aktivieren
	 Scan->bDynamicStepWidth = IsDlgButtonChecked( GetHandle(), id_DynamicActive );

	 //! liest Wert fuer Maximumwinkel und testet ob dieser kleiner ist als der
	 //! max. erlaubte(fuer akt. Motor) wenn kleiner uebernehmen sonst uebernehmen
	 //! von max. erlaubten Winkel - 1* Schrittweite + schreiben in die Box (Box
	 //! wird nicht geschlossen)
	 GetDlgItemText( GetHandle(), id_AngleMax, ( LPSTR ) buf, MaxString );
	 valueF = atof( buf );
    if ( valueF <= mGetValue( MaxDistance ) )
        Scan->dArgumentMax = valueF;
    else
    {
        Scan->dArgumentMax = mGetValue( MaxDistance ) - mGetValue( MinWidth );
        sprintf( buf, mGetDF(), Scan->dArgumentMax );
        SetDlgItemText( GetHandle(), id_AngleMax, ( LPSTR ) buf );
        bFailure = TRUE;
	 }
    //! liest Schrittweite aus Dialogbox und uebernimmt diesen wenn Wert <> 0
	 //! sonst Box wird nicht geschlossen (Fehler)
    GetDlgItemText( GetHandle(), id_AngleWidth, ( LPSTR ) buf, MaxString );
    valueF = atof( buf );
    //! FIX Fehler 8
    if ( mGetValue( MinWidth ) <= valueF )
        Scan->dArgumentWidth = valueF;
	 else
        bFailure = TRUE;

    //! liest Minimum aus Dialogbox und testet ob >= als min. erlaubter Winkel
	 //! des akt. Motors
    GetDlgItemText( GetHandle(), id_AngleMin, ( LPSTR ) buf, MaxString );
	 valueF = atof( buf );
    if ( valueF >= mGetValue( MinDistance ) )
	 {
		  Scan->dArgumentMin = valueF;
        //! wenn ja test ob min >= max dann neu setzen des Dialoginhaltes(min) auf
		  //! max-10*motorschrittweite + box wird nicht geschlossen
        if ( Scan->dArgumentMin >= Scan->dArgumentMax )
        {
            Scan->dArgumentMin = Scan->dArgumentMax - 10.0 * mGetValue( MinWidth );
            sprintf( buf, mGetDF(), Scan->dArgumentMin );
            SetDlgItemText( GetHandle(), id_AngleMin, ( LPSTR ) buf );
            bFailure = TRUE;
        }
    }
	 else
    {
		  //! sonst Dialogelement auf motormin+10*Motorschrittweite setzen + Box wird
        //! nicht geschlossen
        Scan->dArgumentMin = mGetValue( MinDistance ) + 10.0 * mGetValue( MinWidth );
        sprintf( buf, mGetDF(), Scan->dArgumentMin );
        SetDlgItemText( GetHandle(), id_AngleMin, ( LPSTR ) buf );
        bFailure = TRUE;
	 }
    //! liest die Zeit (Beschraenkung) aus Dialogbox und schliesst Box nur wenn
	 //! Wert <>0 (Fehler)
    GetDlgItemText( GetHandle(), id_MaxTime, ( LPSTR ) buf, MaxString );
    valueF = atof( buf );
    //! FIX Fehler 8
	 if ( 0.0 < valueF )
        Scan->fMaxTime = valueF;
	 else
		  bFailure = TRUE;
    //! liest die Impulse (Beschraenkung) aus Dialogbox und schliesst Box nur
    //! wenn Wert<>0 (Fehler)
    GetDlgItemText( GetHandle(), id_MaxCounts, ( LPSTR ) buf, MaxString );
    valueL = atol( buf );
    //! FIX Fehler 8
    if ( 0 < valueL )
        Scan->dwMaxCounts = valueL;
    else
        bFailure = TRUE;
    //! liest Sicherungs-Verzeichnis aus Dialogbox und testet ob Verzeichnis
	 //! exist. durch anlegen der Datei 'check.tmp' wenn erfolgreich dann setzen
    //! des Pfades sonst setzen von 'C:\\' + Box wird nicht verlassen
	 GetDlgItemText( GetHandle(), id_Catalog, ( LPSTR ) Scan->szDataPath, _MAX_PATH
                  );
    // is path writeable
    if ( Scan->szDataPath[ strlen( Scan->szDataPath ) - 1 ] != '\\' )
        strcat( Scan->szDataPath, "\\" );
    _splitpath( Scan->szDataPath, drv, dir, name, ext );
	 _makepath( Scan->szDataPath, drv, dir, "check", "tmp" );
    hfile = OpenFile( Scan->szDataPath, &of, OF_CREATE );
	 if ( -1 != hfile )
    {
        _lclose( hfile );
        remove( Scan->szDataPath );
		  _makepath( Scan->szDataPath, drv, dir, "", "" );
    }
	 else
	 {
        bFailure = TRUE;
        strcpy( Scan->szDataPath, "c:\\" );
    }

   //! test ob 2Theta innerhalb von gueltigem Bereich (sowohl 1. als auch
   //! letzter 2Thetawert
   if ((!bFailure)&&(eScanType == Omega2ThetaScan))
    {
     int nTheta = mlGetIdByName(Theta);
     GetDlgItemText( GetHandle(), id_2Theta, ( LPSTR ) buf, MaxString );
     d2ThetaStart = atof( buf );
     valueF = d2ThetaStart+(Scan->dArgumentMax-Scan->dArgumentMin)*2.0;
     if((d2ThetaStart >= mlGetValue( nTheta, MinDistance ))&&
              (valueF <=mlGetValue( nTheta, MaxDistance )))
      Scan->d2ThetaStart = d2ThetaStart;
     else
      {
       MessageBox(GetFocus(),"Bereichsberschreitung(Theta)",szMessageScan,MBINFO);
		 bFailure = TRUE;
		}

	 }

	 //! sorgt dafuer, dass bei aufgetretenen Fehlern die Box nicht verlassen wird
	 if ( bFailure )
	 {
		  PostMessage( GetHandle(), WM_COMMAND, ( WPARAM ) cm_ParamSet, 0 );
		  return FALSE;
	 }
	 //! uebernehmen der restlichen Dialogeinstell. + Box kann geschlossen werden
	 Scan->eScanType = eScanType;
	 Scan->nMotor = nMotor;
	 Scan->Device = Device;
	 Scan->Monitor = Monitor;
	 Scan->bMonitorUsed = IsDlgButtonChecked( GetHandle(), id_MonitorUsed );
//! Achsenbeschriftung
	 strcpy(Scan->abzisse,mGetAxisName());
	 return TRUE;
};

//*****************************************************************************
//******* Dialog zum Setzen der Scan-Parameter ********************************
//*****************************************************************************

//! konstruktor fuer Dialogeinst. Einstellungen ContinuousScan
//! dabei wird zunaechst der Konstr. fuer Dialogboxen mit dem string der die
//! Resource spezifiziert aufgerufen
#ifdef GermanVersion
TSetupContinuousScan::TSetupContinuousScan( TScan* scan ) :
		  TModalDlg( "ContinuousScan" )
#else
TSetupContinuousScan::TSetupContinuousScan( TScan* scan ) :
		  TModalDlg( "ContinuousScanEng" )
#endif
{
	 //! Parameter von Scanfenster uebernehmen (Fehler)
	 Scan = scan;
	 bSaveOnReady = Scan->bSaveOnReady;
	 dArgumentMin = Scan->dArgumentMin;
	 dArgumentMax = Scan->dArgumentMax;
	 dArgumentWidth = Scan->dArgumentWidth;
	 fMaxTime = Scan->fMaxTime;
	 nCollectionAmount = Scan->nCollectionAmount;
	 dSpeed = Scan->dSpeed;
	 Scan->bSaveContinuous = FALSE;
	 //! uebergeben des akt. Motors und Detektors
	 nMotor = Scan->nMotor;
	 Device = Scan->Device;
};


//#pragma argsused
//! setzt Defaultwerte in Dialogbox
//! Rueckkehrcode immer true
BOOL TSetupContinuousScan::Dlg_OnInit( HWND hwnd, HWND hwndCtl, LPARAM lParam )
{
	 int i = 0;

   //! Min und max event. auf gueltige werte setzen
	 if ( dArgumentMax >= mGetValue( MaxDistance ) )
			dArgumentMax = mGetValue( MaxDistance ) - mGetValue( MinWidth );
	 if ( dArgumentMin <= mGetValue( MinDistance ) )
			dArgumentMin = mGetValue( MinDistance ) + mGetValue( MinWidth );
   //! Speicheroptionen in dialog eintragen
	 CheckDlgButton( GetHandle(), id_SaveOnReady, bSaveOnReady );
	 SetDlgItemText( GetHandle(), id_Path, ( LPSTR ) Scan->szDataPath );
	 //! Handles der Comboboxen uebergeben
	 hDeviceList = GetDlgItem( GetHandle(), id_ChooseDevice );
	 hMotorList = GetDlgItem( GetHandle(), id_ChooseMotor );
	 //! eintragen der Comboboxauswahlelemente fuer Detektor und Scanachse
	 //! vorauswahl der aktiven geraete
	 i = 0;
	 while ( i <= lpDList->LastId() )
		  ComboBox_AddString( hDeviceList, lpDList->DP( i++ ) ->Characteristic );
	 i = -1;
	 while ( ++i < mlGetAxisNumber() )
	 {
		  mlSetAxis( i );
		  ComboBox_AddString( hMotorList, mGetAxisName() );
	 }
   //! wieder alten motor setzen und vorauswaehlen
	 mlSetAxis( nMotor );
	 ComboBox_SelectString( hMotorList, 0, mGetAxisName() );
	 //! eintragen der Messzeit in Dialogbox
	 //! bewirkt Aufruf von Dlg_OnCommand mit Kommando cm_ParamSet
	 FORWARD_WM_COMMAND( hwnd, IDRESET, hwndCtl, 0, SendMessage );
	 return TRUE;
};


//! behandelt alle kommandos in der Dialogbox
//! id = id-Nr. des ausgewaehlten Dialogelements bzw. ein cm_...
void TSetupContinuousScan::Dlg_OnCommand( HWND hwnd, int id, HWND hwndCtl,
		  UINT codeNotify )
{
	 char buf[ MaxString ];
	 int idx;

	 //! abhaengig von dialogelement bzw. Kommando
	 switch ( id )
	 {
			  //! zur initialisierung und bei aenderungen in Comboboxen aufgerufen
	case IDRESET:
			//! eintragen der Messzeit in Dialogbox
			sprintf( buf, "%.1f", fMaxTime );
			SetDlgItemText( GetHandle(), id_MaxTime, ( LPSTR ) buf );
		  //! Bereichsgroesse
			sprintf( buf, mGetSF(), dArgumentWidth );
			SetDlgItemText( GetHandle(), id_StepWidth, ( LPSTR ) buf );
		  //! Endpunkt
			 sprintf( buf, mGetDF(), dArgumentMax );
		  SetDlgItemText( GetHandle(), id_AngleMax, ( LPSTR ) buf );
		  //! Startpunkt
			 sprintf( buf, mGetDF(), dArgumentMin );
		  SetDlgItemText( GetHandle(), id_AngleMin, ( LPSTR ) buf );

   //! Geschwindigkeit, messbereiche, einheit ... aktualisieren
   //! (event. vorher berechnen)
	 case cm_SetupParameters:
	 case cm_ParamSet:
		GetDlgItemText( GetHandle(), id_AngleMin, ( LPSTR ) buf, MaxString );
		dArgumentMin= atof( buf );
		GetDlgItemText( GetHandle(), id_AngleMax, ( LPSTR ) buf, MaxString );
		dArgumentMax= atof( buf );
		GetDlgItemText( GetHandle(), id_StepWidth, ( LPSTR ) buf, MaxString );
		dArgumentWidth= atof( buf );
		GetDlgItemText( GetHandle(), id_MaxTime, ( LPSTR ) buf, MaxString );
		fMaxTime= atof( buf );
		//! Messpunkte
    if (dArgumentWidth != 0.0)
     {
      nCollectionAmount = (( dArgumentMax - dArgumentMin ) /
		dArgumentWidth) + 0.5;
  		sprintf( buf, "%d", nCollectionAmount );
  		SetDlgItemText( GetHandle(), id_NumberSteps, ( LPSTR ) buf );
     }
		//! Geschwindigkeit
    if (fMaxTime != 0.0)
    {
		 dSpeed = dArgumentWidth / fMaxTime;
		 sprintf( buf, mGetDF(), dSpeed );
		 SetDlgItemText( GetHandle(), id_Velocity, ( LPSTR ) buf );
    }
		//! Motor/Detektor
		ComboBox_SelectString( hMotorList, 0, mGetAxisName() );
		ComboBox_SelectString( hDeviceList, 0, Device->Characteristic );
		//! Einheit
		SetDlgItemText( GetHandle(), id_Unit, mGetAxisUnit() );

		  //! Scan-Achsen-Combobox ausgewaehlt
	 case id_ChooseMotor:
		  //! test ob aenderung in combobox
		  switch ( codeNotify )
		  {
				//! ja => setzen des Motors + signal cm_ParamSet wird gesendet um
				//! Einheit u.a. zu aktualisieren
		  case CBN_SELCHANGE:
				idx = ComboBox_GetCurSel( hMotorList );
				if ( ( nMotor != idx ) && ( idx != CB_ERR ) )
				{
					 mlSetAxis( idx );
					 nMotor = mlGetAxis();
					 FORWARD_WM_COMMAND( GetHandle(), cm_ParamSet, 0, 0, PostMessage );
				}
		  }
		  break;

		  //! Detektor-combobox ausgewaehlt
	 case id_ChooseDevice:
		  //! test ob aenderung in combobox
		  switch ( codeNotify )
		  {
				//! ja => setzen des Detektors
				//! und senden cm_ParamSet (hier nicht sinnvoll)
		  case CBN_SELCHANGE:
				idx = ComboBox_GetCurSel( hDeviceList );
				if ( ( Device != lpDList->DP( idx ) ) && ( idx != CB_ERR ) )
				{
					 Device = lpDList->DP( idx );
					 PostMessage( GetHandle(), WM_COMMAND, cm_ParamSet, 0 );
				}
		  }
		  break;

		  //! hier werden IDOK,IDCANCEL und IDABBORT behandelt
	 default:
		  TModalDlg::Dlg_OnCommand( hwnd, id, hwndCtl, codeNotify );
	 }
};


//! realisiert test der Dialogboxinhalte auf ihre konsistenz vor verlassen der
//! Dialogbox (durch OK-Button)
//! Rueckkehrcode False wenn die Dlg.box nicht geschlossen werden kann (werte
//! inkonsistent) sonst true
BOOL TSetupContinuousScan::CanClose( void )
{
	 char buf[ MaxString ];
	 float valueF;
	 BOOL bFailure = FALSE;
	 OFSTRUCT of;
   double dAccelerationDistance=0.0;
	 int hfile;
	 char dir[ _MAX_DIR ], drv[ _MAX_DRIVE ], name[ _MAX_FNAME ], ext[ _MAX_EXT ];

	 mlSetAxis(nMotor);
	 //! Speicher-Optionen
	 bSaveOnReady = IsDlgButtonChecked( GetHandle(), id_SaveOnReady );
	 GetDlgItemText( GetHandle(), id_Path, ( LPSTR ) Scan->szDataPath, _MAX_PATH	);
	 if ( Scan->szDataPath[ strlen( Scan->szDataPath ) - 1 ] != '\\' )
		  strcat( Scan->szDataPath, "\\" );
	 _splitpath( Scan->szDataPath, drv, dir, name, ext );
	 _makepath( Scan->szDataPath, drv, dir, "check", "tmp" );
	 hfile = OpenFile( Scan->szDataPath, &of, OF_CREATE );
	 if ( -1 != hfile )
	 {
		  _lclose( hfile );
		  remove( Scan->szDataPath );
		  _makepath( Scan->szDataPath, drv, dir, "", "" );
	 }
	 else
	 {
		  bFailure = TRUE;
		  strcpy( Scan->szDataPath, "c:\\" );
	 }
	 //! Messpunkte
	 GetDlgItemText( GetHandle(), id_NumberSteps, ( LPSTR ) buf, MaxString );
	 nCollectionAmount = atoi( buf );
	 if ( 0 >= nCollectionAmount )
	 {
		MessageBox(GetFocus(),szMsgLine131,szMsgFailureScan,MBINFO);
		  bFailure = TRUE;
	 }
	 //! Messzeit
	 GetDlgItemText( GetHandle(), id_MaxTime, ( LPSTR ) buf, MaxString );
	 valueF = atof( buf );
	 if ( 0.0 < valueF )
		  fMaxTime = valueF;
	 else
		{
		fMaxTime = 1.0;
		  bFailure = TRUE;
	 }
	 //! Geschwindigkeit
	 valueF = dArgumentWidth / fMaxTime;
	 if(!bFailure)
	  if( ( mGetValue( MaxSpeed ) >= valueF )&&(valueF > 0.0))
		  dSpeed = valueF;
	  else
	  {
		MessageBox(GetFocus(),szMsgLine130,szMsgFailureScan,MBINFO);
		  bFailure = TRUE;
	  }

   if(!bFailure)
    {
     //! Beschleunigungs- bzw. Bremsweg berechnen
	  valueF = (float)mGetValue( Acceleration );
     //! vorerst auskommentiert, da die ini-datei-param. nicht stimmen
	 //! dAccelerationDistance = 0.5 * (dSpeed * dSpeed) / valueF;
    }
	 //! Endpunkt + Bremsweg
	 GetDlgItemText( GetHandle(), id_AngleMax, ( LPSTR ) buf, MaxString );
	 valueF = atof( buf ) + dAccelerationDistance;
	 if ( (valueF <= mGetValue( MaxDistance )) &&
		  (valueF >= (mGetValue(MinDistance) + mGetValue( MinWidth))) )
		  dArgumentMax = valueF - dAccelerationDistance;
	 else
	 {
      char buf2[MaxString];//! neu cont
		  dArgumentMax = mGetValue( MaxDistance ) - mGetValue( MinWidth ) -
                     dAccelerationDistance;
      sprintf(buf2,mGetDF(),dAccelerationDistance);
      sprintf(buf,szMsgLine132,buf2);
      MessageBox(GetFocus(),buf,szMsgFailureScan,MBINFO);
		  bFailure = TRUE;
	 }
	 //! Bereichsgroesse
	 GetDlgItemText( GetHandle(), id_StepWidth, ( LPSTR ) buf, MaxString );
	 valueF = atof( buf );
	 if ( mGetValue( MinWidth ) <= valueF )
		  dArgumentWidth = valueF;
	 else
		  {
		dArgumentWidth = mGetValue( MinWidth );
		bFailure = TRUE;
		}
	 //! Startpunkt - beschleunigungsweg
	 GetDlgItemText( GetHandle(), id_AngleMin, ( LPSTR ) buf, MaxString );
	 valueF = atof( buf ) - dAccelerationDistance;//! neu cont
	 if ( (valueF >= mGetValue( MinDistance ))&& (valueF <= mGetValue( MaxDistance)) )
	 {
		  dArgumentMin = valueF + dAccelerationDistance;
		  if ( dArgumentMin >= dArgumentMax )
		  {
		   valueF = dArgumentMin;
		   dArgumentMin = dArgumentMax;
		   dArgumentMax = valueF;
			 bFailure = TRUE;
		  }
	 }
	 else
	 {
      char buf2[MaxString];
		  dArgumentMin = mGetValue( MinDistance ) + dAccelerationDistance;
      sprintf(buf2,mGetDF(),dAccelerationDistance);//! neu cont
      sprintf(buf,szMsgLine132,buf2);
      MessageBox(GetFocus(),buf,szMsgFailureScan,MBINFO);
		  bFailure = TRUE;
	 }
	 //! Messpunkte
	 nCollectionAmount = ( dArgumentMax - dArgumentMin ) /
			dArgumentWidth + 1;

	 if ( bFailure )
	 {
		  PostMessage( GetHandle(), WM_COMMAND, ( WPARAM ) IDRESET, 0 );
		  return FALSE;
	 }
	//! wenn keine Fehler
	 if(!bFailure)
	 {
	  //! Motor + Detektor
	  Scan->Device = Device;
	  Scan->nMotor = nMotor;
	 //! Parameter uebernehmen
	 Scan->dArgumentMin = dArgumentMin;
	 Scan->dArgumentMax = dArgumentMax;
	 Scan->dArgumentWidth = dArgumentWidth;
	 Scan->dSpeed = dSpeed;
	 Scan->nCollectionAmount = nCollectionAmount;
	 Scan->fMaxTime = fMaxTime;
	 Scan->bSaveOnReady = bSaveOnReady;
	 //! Scantyp
	  Scan->eScanType = ContinuousScan;
	  //! Achsenbeschriftung
	  strcpy(Scan->abzisse,mGetAxisName());
	 }
	 return TRUE;
};


//! Aenderung Dynamische Schrittweite
//! Dialogbox-Klasse fuer Einstellungen Dynamische Schrittweite
//! Konstruktor
TSetupDynamicStep::TSetupDynamicStep( TScan* scan ) : TModalDlg( "DynamicStepWidth" )
{
	//! Einlesen der Id's in Feld-Variablen zur komfortableren Nutzung
	Scan = scan;
	IntensityId[0] = id_Intensity_0;
	FactorId[0] = id_Factor_0;
	StaticId[0] = id_Static_0;
	IntensityId[1] = id_Intensity_1;
	FactorId[1] = id_Factor_1;
	StaticId[1] = id_Static_1;
	IntensityId[2] = id_Intensity_2;
	FactorId[2] = id_Factor_2;
	StaticId[2] = id_Static_2;
	IntensityId[3] = id_Intensity_3;
	FactorId[3] = id_Factor_3;
	StaticId[3] = id_Static_3;
	IntensityId[4] = id_Intensity_4;
	FactorId[4] = id_Factor_4;
	StaticId[4] = id_Static_4;
	IntensityId[5] = id_Intensity_5;
	FactorId[5] = id_Factor_5;
	StaticId[5] = id_Static_5;
	IntensityId[6] = id_Intensity_6;
	FactorId[6] = id_Factor_6;
	StaticId[6] = id_Static_6;
	IntensityId[7] = id_Intensity_7;
	FactorId[7] = id_Factor_7;
	StaticId[7] = id_Static_7;
	IntensityId[8] = id_Intensity_8;
	FactorId[8] = id_Factor_8;
	StaticId[8] = id_Static_8;
	IntensityId[9] = id_Intensity_9;
	FactorId[9] = id_Factor_9;
	StaticId[9] = id_Static_9;
};

//#pragma argsused
//! setzt Defaultwerte der Dialogbox bei Aufruf der Box
//! Rueckkehrcode immer true
BOOL TSetupDynamicStep::Dlg_OnInit(HWND hwnd, HWND hwndCtl, LPARAM lParam)
{
  PostMessage( GetHandle(), WM_COMMAND, ( WPARAM ) IDRESET, 0 );
  return TRUE;
};

//#pragma argsused
//! behandelt alle kommandos der Dialogbox
void TSetupDynamicStep::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
{
  char buf[MaxString];
  int idx;

	 switch( id )
	 {
	  //! Kommando cm_ParamSet
	  case cm_ParamSet:
	  //! Eintragen der Dialogbox-Elemente
	  for( idx=0; idx< nMaxScaleIdx; idx++ )
	  {
		sprintf( buf, "%.0f", ScalerDummy[idx]);
		SetDlgItemText( GetHandle(), IntensityId[ idx ], ( LPSTR ) buf );
		sprintf( buf, "%.2f", ScalerDummy[idx+nMaxScaleIdx]);
		SetDlgItemText( GetHandle(), FactorId[ idx ], ( LPSTR ) buf );
	  }
	  SetDlgItemText( GetHandle(), StaticId[ 0 ], "0");
	  for( idx=1; idx< nMaxScaleIdx; idx++ )
	  {
		sprintf( buf, "%.0f", ScalerDummy[idx-1]+1);
		SetDlgItemText( GetHandle(), StaticId[ idx ], ( LPSTR ) buf );
	  }
	  break;

	 //! Kommando IDRESET
	 case IDRESET:
	 //! Uebernahme der Ursprungswerte in die Arbeits-Variablen + Kommando
	 //! cm_ParamSet senden
	 for( idx=0; idx< nMaxScaleIdx; idx++ )
	 {
		ScalerDummy[idx]=Scan->Scaler[idx];
		ScalerDummy[idx+nMaxScaleIdx]=Scan->Scaler[idx+nMaxScaleIdx];
	 }
	 PostMessage( GetHandle(), WM_COMMAND, ( WPARAM ) cm_ParamSet, 0 );
	 break;

	 //! behandelt IDOK, IDCANCEL
	 default:
	 TModalDlg::Dlg_OnCommand( hwnd, id, hwndCtl, codeNotify );
	 }
};

//! realisiert test der Dialogboxinhalte auf ihre konsistenz vor verlassen
//! der Dialogbox (durch OK-Button)
//! Rueckkehrcode False wenn die Dlg.box nicht geschlossen werden kann
//! (Werte inkonsistent) sonst true
BOOL TSetupDynamicStep::CanClose()
{
  char buf1[MaxString], buf2[MaxString];
  float valueF;
  int idx=0;
  float fMaxIntensity=0.0;
  BOOL retval=TRUE;

  //! Auslesen der Dialogbox-Elemente
  for( idx; idx< nMaxScaleIdx; idx++ )
  {
	GetDlgItemText( GetHandle(), IntensityId[ idx ], ( LPSTR ) buf1, MaxString );
	valueF = atof( buf1 );
	ScalerDummy[ idx ] = valueF;
	GetDlgItemText( GetHandle(), FactorId[ idx ], ( LPSTR ) buf2, MaxString );
	valueF = atof( buf2 );
	ScalerDummy[ idx + nMaxScaleIdx ] = valueF;
  }

  //! Bestimmung der maximal vorkommenden Intensitaet
  for( idx=0; idx< nMaxScaleIdx; idx++ )
	if( ScalerDummy[ idx ] > fMaxIntensity ) fMaxIntensity = ScalerDummy[ idx ];

  //! inkorrekte Intensitaeten bestimmen
  //! Faktor auf 1 und Intensitaet auf Maximalen Wert +1 setzen
  for( idx=0; idx< nMaxScaleIdx; idx++ )
	if( ScalerDummy[ idx ] <=0 )
	{
	 ScalerDummy[ idx ] = ++fMaxIntensity;
	 ScalerDummy[ idx+nMaxScaleIdx ] = 1.0;
	 retval=FALSE;
	}

  // Sortieren der Intensitaeten
  float dummy;
  for( idx=0; idx<nMaxScaleIdx-1; idx++ )
	for( int idy=idx+1; idy<nMaxScaleIdx; idy++ )
	{
	 if( ScalerDummy[ idx ] > ScalerDummy[ idy ] )
	 {
	  dummy = ScalerDummy[ idx ];
	  ScalerDummy[ idx ] = ScalerDummy[ idy ];
	  ScalerDummy[ idy ] = dummy;
	  dummy = ScalerDummy[ idx+nMaxScaleIdx ];
	  ScalerDummy[ idx+nMaxScaleIdx ] = ScalerDummy[ idy+nMaxScaleIdx ];
	  ScalerDummy[ idy+nMaxScaleIdx ] = dummy;
	  retval = FALSE;
	 }
	}

  //! Behandlung doppelt vorkommender Intensitaeten
  //! Faktor auf 1 und Intensitaet auf Maximalen Wert +1 setzen
  for( idx=1; idx<nMaxScaleIdx; idx++ )
  {
	if( ScalerDummy[ idx-1 ] == ScalerDummy[ idx ] )
	{
	 ScalerDummy[ idx ] = ++fMaxIntensity;
	 ScalerDummy[ idx+nMaxScaleIdx ] = 1.0;
	 retval=FALSE;
	}
  }

  // erneutes Sortieren der Intensitaeten
  for( idx=0; idx<nMaxScaleIdx-1; idx++ )
	for( int idy=idx+1; idy<nMaxScaleIdx; idy++ )
	{
	 if( ScalerDummy[ idx ] > ScalerDummy[ idy ] )
	 {
	  dummy = ScalerDummy[ idx ];
	  ScalerDummy[ idx ] = ScalerDummy[ idy ];
	  ScalerDummy[ idy ] = dummy;
	  dummy = ScalerDummy[ idx+nMaxScaleIdx ];
	  ScalerDummy[ idx+nMaxScaleIdx ] = ScalerDummy[ idy+nMaxScaleIdx ];
	  ScalerDummy[ idy+nMaxScaleIdx ] = dummy;
	 }
	}

  //! Test auf korrekte Faktor-Werte
  for( idx=0; idx<nMaxScaleIdx; idx++ )
	if( ScalerDummy[ idx+nMaxScaleIdx ] <= 0 )
	{
	 ScalerDummy[ idx+nMaxScaleIdx ] = 1;
	 retval = FALSE;
	}

  //! bei Fehler Korrektor und Box bleibt geoeffnet
  if ( !retval )
	PostMessage( GetHandle(), WM_COMMAND, ( WPARAM ) cm_ParamSet, 0 );
  else
	  for( idx=0; idx< nMaxScaleIdx; idx++ )
	  {
		Scan->Scaler[idx]=ScalerDummy[idx];
		Scan->Scaler[idx+nMaxScaleIdx]=ScalerDummy[idx+nMaxScaleIdx];
	  }
  return retval;
};

// __LastLine__

