#ifndef _L_LAYER_H
#define _L_LAYER_H


#define    W_ImageWindow       250
#define    W_OffLineWindow     256


#define    I_Position          280
#define    I_Intensity         281
#define    I_Report            282
// Voreinstellungen
#define    CONTROL             0x02
#define    NOCONTROL           0xFD
#define    ECHO                0x04
#define    NOECHO              0xFB
#define    MAXERROR            10


//*** Return-Codes
/* Benutzt in m_main.cpp */
#define  R_Stopped         200
/* NICHT BENUTZT */
//! #define  R_Started         201
/* Benutzt in m_main.cpp */
#define  R_NoWindow        203
/* NICHT BENUTZT */
//! #define  R_InvalidFile     204
/* NICHT BENUTZT */
//! #define  R_MeasStop        207
/* NICHT BENUTZT */
//! #define  R_NoCommunication 208
/* NICHT BENUTZT */
//! #define  R_NoMemory        209
/* NICHT BENUTZT */
//! #define  R_NoMfSelected    210
/* NICHT BENUTZT */
//! #define  R_Restarted       211
/* NICHT BENUTZT */
//! #define  R_Interrupted     212
/* NICHT BENUTZT */
//! #define  R_DataValid       213

/* Benutzt in m_main.cpp */
typedef enum
{ 
  HRM = 1, RTK, ScanTable, PDI_Diffractometer, Diff2, Diff3, Expert
} TWorkPlace;


#define MainWindow_Style WS_CLIPCHILDREN | WS_OVERLAPPED |  \
             WS_CAPTION | WS_THICKFRAME |       \
             WS_MINIMIZEBOX | WS_MAXIMIZEBOX |  \
             WS_SYSMENU

#define ClientWindow_Style WS_CHILD | WS_CLIPCHILDREN | WS_VSCROLL | WS_HSCROLL
typedef struct
{
 short      nFontType;
 LOGFONT    lf;
 TEXTMETRIC tm;
 } T_Font;


void  NewWindow( TMDIWindow* );
/* NICHT BENUTZT */
//! #define O_Common     0x0004

// Identifikation der Timer
/* NICHT BENUTZT */
//! #define MotorTimerIdStart    200
/* NICHT BENUTZT */
//! #define GenericTimerIdStart  300
/* Benutzt in m_main.cpp */
#define   TimerIdSteering    398

#ifdef __cplusplus
extern "C" {
#endif
BOOL       __declspec(dllexport) WINAPI InitializeSPLibrary( TMainParameters* );
void       __declspec(dllexport) WINAPI AboutTheMaker( void );
int        __declspec(dllexport) WINAPI GetBufferLine( LPSTR, LPSTR, int );
LPCSTR     __declspec(dllexport) WINAPI spGetVersion( void );
HINSTANCE  __declspec(dllexport) WINAPI spGetInstance( void );
LPSTR      __declspec(dllexport) WINAPI UnitStr( TUnitType );
int        __declspec(dllexport) WINAPI maxi( int, int );
long       __declspec(dllexport) WINAPI maxl( long, long );
float      __declspec(dllexport) WINAPI maxf( float, float );
double     __declspec(dllexport) WINAPI maxd( double, double );
int        __declspec(dllexport) WINAPI mini( int, int );
long       __declspec(dllexport) WINAPI minl( long, long );
float      __declspec(dllexport) WINAPI minf( float, float );
double     __declspec(dllexport) WINAPI mind( double, double );
#ifdef __cplusplus
}
#endif

///////////////////////////////////////////////////////////////////////
// ! neu Kullmann+Reinecker:           TFileLocations
// impl. in "m_main.cpp" war nicht mglich (Sichtbarkeit in allen Modulen! )
///////////////////////////////////////////////////////////////////////

class TFileLocations {
public:
  _declspec(dllexport) TFileLocations( LPCSTR directory, LPCSTR name );   

  //auslesen von szDirectory
  LPCSTR GetDirectory( void ); 

  //auslesen von szName
  LPCSTR GetName( void );

public:
  //vollstaendiger Name der Hardware-INI
  LPCSTR GetHWFile( void );

  //vollstaendiger Name der Conf.-INI
  LPCSTR GetCFile( void );

  //vollst. Name der "TestDev.dat"
  LPCSTR GetTestDevFile( void );

  //vollst. Name der <macroname>; <macroname> sollte auf ".mak" enden (z.B. "scan.mak" oder "standard.mak")
  LPCSTR GetMacroFile( LPCSTR macroname );

private:
  //Laufwerk+Verzeichnis, aus dem aktuelle Anwendung gestartet wurde
  char szDirectory[_MAX_PATH];

  //Dateiname (ohne Laufwerk+Verzeichnis) der aktuellen Anwendung
  char szName[_MAX_PATH];
};

#endif
