#include  "..\include\winresrc\rc_def.h"
#include  "..\include\internls\evrythng.h"
//#pragma hdrstop
//#include <commdlg.h>
#include <time.h>
#include "..\include\swintrac\swintrac.h"
#include "..\include\datavisa\datavisa.h"

#include  "..\include\internls\l_layer.h"

// l_layer.cpp
// (C) 1993,1994 by Heiko Damerow MPG AG "Roentgenbeugung"
// Allgemeine Funktionen

TMainParameters			MainP;

// ! neu Kullmann+Reinecker
//mit InitializeFileLocations bernommen aus TMain::FileLocations
TFileLocations      *FileLocations; 

int               	bModulLoaded = FALSE;
//HANDLE 							hTheModule;
HINSTANCE         	hModuleInstance;
extern LPDataBase 	lpDataBase;

static  char        spVersion[] = "V 1.51 ("__DATE__")";


class TAbout : public TModalDlg
	{
	public:			 TAbout(void);
	private:
	BOOL         Dlg_OnInit(HWND,HWND,LPARAM);
	void         Dlg_OnCommand(HWND,int,HWND,UINT);
	BOOL         LeaveDialog(void) {return TRUE;};
	};

#ifdef _WIN32
BOOL WINAPI DllMain(HINSTANCE hModule, DWORD dwFunction, LPVOID  )
	{
	switch (dwFunction)
		{
		case DLL_PROCESS_ATTACH:
		// Initialize function array.
		bModulLoaded = FALSE;
		hModuleInstance = hModule;
		lpDataBase = (LPDataBase)new TDataBase();
		break;
		};
	return TRUE;
	}

#else
int FAR PASCAL LibMain(HINSTANCE hInstance,WORD,WORD wHeapSize,LPSTR)
	{
	if(wHeapSize != 0)
		UnlockData(0);
	bModulLoaded = FALSE;
	hModuleInstance = hInstance;
	lpDataBase = (LPDataBase)new TDataBase();
	return 1;
	};

//#pragma argsused
int CALLBACK WEP(int bSystemExit)
	{
	bModulLoaded = FALSE;
	return 1;
	};
#endif

LPCSTR __declspec(dllexport) WINAPI spGetVersion(void)
	{
	return (LPCSTR)spVersion;
	};

HINSTANCE __declspec(dllexport) WINAPI spGetInstance(void)
	{
	return hModuleInstance;
	};

//******************************************************************************
//************** Autorisierungs-System *****************************************
//******************************************************************************
static	char AuthorAddress[] 	= "damerow@nz.dlr.de";
static	char WorkAddress[] 		= "Kalkhorstweg 53\n" \
																"17235 Neustrelitz\n" \
																"damerow@nz.dlr.de";
static	char AuthorName[]			= "Heiko Damerow";
static	char CoAuthorName[]		= "Heiko Brandhorst (Braun-Psd-Interface)";
/*
	Asa.DLL
		- Code knnte durch eigenen Code ersetzt werden

	Radicon-Zhler
	 - Code zur Ansteuerung der Radicon-Zhler
*/

void __declspec(dllexport) WINAPI AboutTheMaker(void)
	{
	TAbout* dlg = new TAbout();
	dlg->ExecuteDialog(GetFrameHandle());
	delete dlg;
	};

TAbout::TAbout() : TModalDlg("About")
	{
	};

BOOL TAbout::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM)
	{
	char  HeadLine[MaxString];

	strcpy(HeadLine,"ber Steuerprogramm");
	SetWindowText(hwnd,HeadLine);
	SetDlgItemText(hwnd,cm_ShowAuthorName,AuthorName);
	SetDlgItemText(hwnd,cm_ShowCoAuthorName,CoAuthorName);
	TModalDlg::Dlg_OnInit(hwnd,hwndCtl,0l);
	return TRUE;
	};

void TAbout::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
	{
	switch(id)
		{
		case cm_ShowWorkAddress:
		MessageBox(GetFocus(),WorkAddress,"Adresse",MBINFO);
		break;

		case cm_ShowAuthorAddress:
		MessageBox(GetFocus(),AuthorAddress,"Adresse",MBINFO);
		break;

		default:
		TModalDlg::Dlg_OnCommand(hwnd,id,hwndCtl,codeNotify);
		}
	};

//******************************************************************************
//******************************************************************************

//! bestimmt 3 Integerwerte zwischen -9 und 9 aus einem String
//! wird nur in Verbindung mit Orientation,Reflection benutzt
//! 1.Parameter(ausgabe) Struktur von 3 integerwerten
//! 2.Parameter(eingabe) String
void __declspec(dllexport) SetHKL( THKL& refl, LPCSTR info )
{
	 int i;
	 THKL nr;

	 i = 0;
	 while ( '[' == info[ i ] ) i++;
	 while ( ' ' == info[ i ] ) i++;
	 if ( '-' == info[ i ] )
		  nr.h = max( '0' - info[ ++i ], -9 );
	 else
		  nr.h = min( info[ i ] - '0', 9 );
	 if ( '-' == info[ ++i ] )
        nr.k = max( '0' - info[ ++i ], -9 );
    else
        nr.k = min( info[ i ] - '0', 9 );
	 if ( '-' == info[ ++i ] )
        nr.l = max( '0' - info[ ++i ], -9 );
    else
        nr.l = min( info[ i ] - '0', 9 );
    refl = nr;
};


//! bildet aus 3 Integerwerten einen String
//! wird nur in Verbindung mit Orientation,Reflection benutzt
//! 1.Parameter(eingabe) Struktur von 3 integerwerten
//! 2.Parameter(ausgabe) String
void __declspec(dllexport) GetHKL( THKL& refl, LPSTR info )
{
    sprintf( info, "[%d%d%d]", refl.h, refl.k, refl.l );
};


///////////////////////////////////////////////////////////////////////
// ! neu Kullmann+Reinecker:           TFileLocations
// impl. in "m_main.cpp" war nicht mglich (Sichtbarkeit in allen Modulen! )
///////////////////////////////////////////////////////////////////////

  __declspec(dllexport) TFileLocations::TFileLocations( LPCSTR directory, LPCSTR name ) {
    strcpy(szDirectory, directory);
    strcpy(szName, name);
  };

  //auslesen von szDirectory
  LPCSTR TFileLocations::GetDirectory( void ) {
    char *result = (char*)malloc (sizeof(char)*(_MAX_PATH+1)); //+1 wegen dem terminierenden 0-Zeichen !!!
    strcpy(result, szDirectory);
    return result;
  };

  //auslesen von szName
  LPCSTR TFileLocations::GetName( void ) {
    char *result = (char*)malloc (sizeof(char)*(_MAX_PATH+1)); //+1 wegen dem terminierenden 0-Zeichen !!!
    strcpy(result, szName);
    return result;
  };

  //vollstaendiger Name der Hardware-INI
  LPCSTR TFileLocations::GetHWFile( void ) {
    char *result = (char*)malloc (sizeof(char)*(_MAX_PATH+1)); //+1 wegen dem terminierenden 0-Zeichen !!!
    strcpy( result, GetDirectory() );
    strcat( result, "hardware.ini" );
    return result;
  };

  //vollstaendiger Name der Conf.-INI
  LPCSTR TFileLocations::GetCFile( void ) {
    char *result = (char*)malloc (sizeof(char)*(_MAX_PATH+1)); //+1 wegen dem terminierenden 0-Zeichen !!!
    strcpy( result, GetDirectory() );
    strcat( result, GetName() );
    strcat( result, ".ini" );
    return result;
  };

  //vollst. Name der "TestDev.dat"
  LPCSTR TFileLocations::GetTestDevFile( void ) {
    char *result = (char*)malloc (sizeof(char)*(_MAX_PATH+1)); //+1 wegen dem terminierenden 0-Zeichen !!!
    strcpy( result, GetDirectory() );
    strcat( result, "testdev.dat" );
    return result;
  };

  //vollst. Name der <macroname>; <macroname> sollte auf ".mak" enden (z.B. "scan.mak" oder "standard.mak")
  LPCSTR TFileLocations::GetMacroFile( LPCSTR macroname ) {
    char *result = (char*)malloc (sizeof(char)*(_MAX_PATH+1)); //+1 wegen dem terminierenden 0-Zeichen !!!
    strcpy( result, GetDirectory() );
    strcat( result, macroname );
    return result;
  };


///////////////////////////////////////////////////////////////////////
// ! neu Kullmann+Reinecker            Init. und Auslesen von FileLocations
////////////////////////////////////////////////////////////////////////////////

void __declspec(dllexport) WINAPI InitializeFileLocations(TFileLocations* fl) {
	FileLocations= fl;
};

LPCSTR __declspec(dllexport) WINAPI GetDirectory( void ) {
  return FileLocations->GetDirectory();
};

LPCSTR __declspec(dllexport) WINAPI GetName( void ) {
  return FileLocations->GetName();
};

LPCSTR __declspec(dllexport) WINAPI GetHWFile( void ) {
  return FileLocations->GetHWFile();
};

LPCSTR __declspec(dllexport) WINAPI GetCFile( void ) {
  return FileLocations->GetCFile();
};

LPCSTR __declspec(dllexport) WINAPI GetTestDevFile( void ) {
  return FileLocations->GetTestDevFile();
};

LPCSTR __declspec(dllexport) WINAPI GetMacroFile( LPCSTR macroname ) {
  return FileLocations->GetMacroFile( macroname ); 
};

///////////////////////////////////////////////////////////////////////
//                  Initialisieren und Auslesen von MainP
///////////////////////////////////////////////////////////////////////

HWND __declspec(dllexport) WINAPI GetFrameHandle(void)
	{
	return MainP.hWndFrame;
	};

HWND __declspec(dllexport) WINAPI GetClientHandle(void)
	{
	return MainP.hWndClient;
	};

HINSTANCE __declspec(dllexport) WINAPI GetMainInstance(void)
	{
	return MainP.hInstance;
	};

LPDataBase __declspec(dllexport) WINAPI GetDataBasePtr(void)
	{
	if(!bModulLoaded) return NULL;
	return (LPDataBase)lpDataBase;
	};

BOOL __declspec(dllexport) WINAPI InitializeSPLibrary(TMainParameters* MainParam)
	{
	MainP = *MainParam;
	bModulLoaded = TRUE;
	return TRUE;
	};

TxScanType __declspec(dllexport) WINAPI ParsingXScanType(LPSTR xst)
	{
	if(!strcmp(xst,"Standard")) 			return StandardScan;
	if(!strcmp(xst,"Omega2Theta")) 		return Omega2ThetaScan;
	if(!strcmp(xst,"Continuous")) 		return ContinuousScan;
	if(!strcmp(xst,"PsdEnergyScan")) 	return PsdEnergyScan;
	if(!strcmp(xst,"PsdPositionScan"))return PsdPositionScan;
	if(!strcmp(xst,"Omega2ThetaList"))return Omega2ThetaScanList;
	if(!strcmp(xst,"ScanList")) 			return ScanList;
	return (TxScanType)0;
	};

BOOL __declspec(dllexport) WINAPI CreateDefaults(void)
	{
	return MainP.bCreateIniDefaults;
	};

void __declspec(dllexport) WINAPI SetInfo(LPCSTR status_txt)
	{
	ATOM        hAtom;

	hAtom = GlobalAddAtom(status_txt);
	if(hAtom)
		SendMessage(MainP.hWndFrame,MainP.wm_DrawStatus,1002,(LONG)hAtom);
	};

void __declspec(dllexport) WINAPI SetStaticInfo(LPCSTR status_txt)
	{
	ATOM        hAtom;

	hAtom = GlobalAddAtom(status_txt);
	if(hAtom)
		PostMessage(MainP.hWndFrame,MainP.wm_DrawStatus,1000,(LONG)hAtom);
	};


void __declspec(dllexport) WINAPI SetStatus(LPCSTR status_txt)
	{
	ATOM        hAtom;

	hAtom = GlobalAddAtom(status_txt);
	if(hAtom)
		PostMessage(MainP.hWndFrame,MainP.wm_DrawStatus,1001,(LONG)hAtom);
	};

BOOL __declspec(dllexport) WINAPI FileOpen(LPCSTR HeadLine,LPSTR szFilter,LPSTR szFileName,LPCSTR StartupPath)
	{
	OPENFILENAME 	ofnTemp;
	DWORD 				Errval; 	// Error value
	char 					buf[5];  	// Error buffer
	char 					Errstr[50]="GetOpenFileName returned Error #";
	char					chSeperator = '|';
	int						i;

	ofnTemp.lStructSize = sizeof(OPENFILENAME);
	ofnTemp.hwndOwner = MainP.hWndFrame; // An invalid hWnd causes non-modality
	ofnTemp.hInstance = 0;
	ofnTemp.lpstrFilter = (LPSTR)szFilter;  // See previous note concerning string
	ofnTemp.lpstrCustomFilter = NULL; //(LPSTR)szFilter;
	ofnTemp.nMaxCustFilter = 0; //strlen(szFilter);
	ofnTemp.nFilterIndex = 1;
	ofnTemp.lpstrFile = (LPSTR)szFileName;  // Stores the result in this variable
	ofnTemp.nMaxFile = _MAX_PATH;
	ofnTemp.lpstrFileTitle = NULL;
	ofnTemp.nMaxFileTitle = 0;
	ofnTemp.lpstrInitialDir = StartupPath;
	ofnTemp.lpstrTitle = HeadLine;
	ofnTemp.Flags = OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST;
	ofnTemp.nFileOffset = 0;
	ofnTemp.nFileExtension = 0;
	ofnTemp.lpstrDefExt = NULL;
	ofnTemp.lCustData = NULL;
	ofnTemp.lpfnHook = NULL;
	ofnTemp.lpTemplateName = NULL;
	/*
	If the call to GetOpenFileName() fails you can call CommDlgExtendedError()
	to retrieve the type of error that occured.
	*/
	for(i = 0;szFilter[i] != '\0';i++)
		if(szFilter[i] == chSeperator)
			 szFilter[i] = '\0';
	if(!GetOpenFileName(&ofnTemp))
		{
		Errval = CommDlgExtendedError();
		if(Errval) // 0 value means user selected Cancel
			{
			sprintf(buf,"%ld",Errval);
			strcat(Errstr,buf);
			MessageBox(MainP.hWndFrame,Errstr,"WARNING",MB_OK|MB_ICONSTOP);
			}
		return FALSE;
		}
	InvalidateRect(MainP.hWndFrame, NULL, TRUE ); // Repaint to display the new name
	return TRUE;
	};

BOOL __declspec(dllexport) WINAPI FileSave(LPCSTR HeadLine,LPSTR szFilter,LPSTR szFileName,LPCSTR StartupPath)
	{
	OPENFILENAME 	ofnTemp;
	DWORD 				Errval; 	// Error value
	char 					buf[5];  	// Error buffer
	char 					Errstr[50] = "GetSaveFileName returned Error #";
	char					chSeperator = '|';
	int						i;

	ofnTemp.lStructSize = sizeof(OPENFILENAME);
	ofnTemp.hwndOwner = MainP.hWndFrame; // An invalid hWnd causes non-modality
	ofnTemp.hInstance = 0;
	ofnTemp.lpstrFilter = szFilter;  // See previous note concerning string
	ofnTemp.lpstrCustomFilter = NULL; //(LPSTR)szFilter;
	ofnTemp.nMaxCustFilter = 0; //strlen(szFilter);
	ofnTemp.nFilterIndex = 1;
	ofnTemp.lpstrFile = (LPSTR)szFileName;  // Stores the result in this variable
	ofnTemp.nMaxFile = _MAX_PATH;
	ofnTemp.lpstrFileTitle = NULL;
	ofnTemp.nMaxFileTitle = 0;
	ofnTemp.lpstrInitialDir = StartupPath;
	ofnTemp.lpstrTitle = HeadLine;
	ofnTemp.Flags = OFN_HIDEREADONLY | OFN_READONLY | OFN_OVERWRITEPROMPT;
	ofnTemp.nFileOffset = 0;
	ofnTemp.nFileExtension = 0;
	ofnTemp.lpstrDefExt = NULL;
	ofnTemp.lCustData = NULL;
	ofnTemp.lpfnHook = NULL;
	ofnTemp.lpTemplateName = NULL;
	/*
	If the call to GetOpenFileName() fails you can call CommDlgExtendedError()
	to retrieve the type of error that occured.
	*/
	for(i = 0;szFilter[i] != '\0';i++)
		{
		if(szFilter[i] == chSeperator)
			 szFilter[i] = '\0';
		}
	if(!GetSaveFileName(&ofnTemp))
		{
		Errval = CommDlgExtendedError();
		if(Errval) // 0 value means user selected Cancel
			{
			sprintf(buf,"%ld",Errval);
			strcat(Errstr,buf);
			MessageBox(MainP.hWndFrame,Errstr,"WARNING",MB_OK|MB_ICONSTOP);
			}
		return FALSE;
		}
	InvalidateRect(MainP.hWndFrame,NULL,TRUE); // Repaint to display the new name
	return TRUE;
	};

BOOL __declspec(dllexport) WINAPI SetFPOnData(HFILE hfile)
	{
	char    data;
	char*   buf;
	//! BOOL	  EoH = FALSE;
	int     cnt,cntfp;

	// the file pointer will be set on the first character after
	// the key [Data] and any whitespaces (\r \n \t _)
	buf = new char[21];
	_llseek(hfile,0,0);
	cntfp = 0;
	while(_lread(hfile,&data,1))
		{
		cntfp++;
		if(data == '[')
			{
			cnt = 0;
			while(_lread(hfile,&data,1))
				{
				cntfp++;
				if(data == ']')
					{
					buf[cnt++] = 0;
					if(strstr(buf,"Data"))
						goto Finish;
						else
						goto SearchAgain;
					}
				buf[cnt++] = data;
				} // after break
			delete[] buf;
			return FALSE;
			}
SearchAgain: ;
		}
	delete[] buf;
	return FALSE;
Finish:
	while(_lread(hfile,&data,1))
		{
		if(data == ' ')   continue;
		if(data == '\r')  continue;
		if(data == '\n')  continue;
		if(data == '\t')  continue;
		_llseek(hfile,-1,1);
		delete[] buf;
		return TRUE;
		}
	delete[] buf;
	return FALSE;
	};

int __declspec(dllexport) WINAPI GetBufferLine(LPSTR src,LPSTR dst,int dstsize)
	{
	static LPSTR			Source = NULL;
	static WORD       cnt_s;
	BOOL							EoL = FALSE;
	char							data;
	int               cnt_d = 0;

	if(src != NULL)
		{
		Source = src;
		cnt_s = 0;
		}
	if(!Source) return FALSE;
	if(Source[cnt_s] == '\0') return FALSE;
	do {
		data = Source[cnt_s++];
		switch(data) {
			case '\n': case '\r':
			data = Source[cnt_s++];
			if(EoL) goto Ready;
			EoL = TRUE;
			continue;

			case '\0':
			dst[cnt_d] = '\0';
			return R_EndOfFile;

			default:
			dst[cnt_d++] = data;
			}
		}
		while(cnt_d < dstsize);
Ready:
	dst[cnt_d] = '\0';
	return TRUE;
	};

int __declspec(dllexport) WINAPI GetFileLine(int hFile,LPSTR dst,int dstsize)
	{
	char  data;
	BOOL	EoL = FALSE;
	int 	cnt = 0;
	int 	rdl;

	dst[cnt] = '\0';
	if(hFile == -1) return FALSE;
	do
		{
		rdl = _lread(hFile,&data,1);
		switch(data) {
			case '\n': case '\r':
			rdl = _lread(hFile,&data,1);
			if(EoL) goto Ready;
			EoL = TRUE;
			continue;

			case '\0':
			dst[cnt] = '\0';
			return R_EndOfFile;

			default:
			if(EoL) goto Ready;
			dst[cnt++] = data;
			}
		}
		while(cnt < dstsize);
Ready:
	_llseek(hFile,-1,SEEK_CUR);
	dst[cnt] = '\0';
	if(cnt == dstsize)
		{
		// overflow dst
		return R_Overflow;
		};
	if(!rdl) return R_EndOfFile;
	return TRUE;
	};

TUnitType __declspec(dllexport) WINAPI UnitEnum(LPSTR sz_unit)
	{
	char  buf[MaxString];
	strcpy(buf,sz_unit);
	strupr(buf);
	if(strstr((LPSTR)buf,"GRAD"))	 			return Grad;
	if(strstr((LPSTR)buf,"SEKUNDEN")) 	return Sekunden;
	if(strstr((LPSTR)buf,"MINUTEN")) 		return Minuten;
	if(strstr((LPSTR)buf,"MINUTS")) 		return Minuten;
	if(strstr((LPSTR)buf,"MILLIMETER")) return Millimeter;
	if(strstr((LPSTR)buf,"MIKROMETER")) return Mikrometer;
	if(strstr((LPSTR)buf,"MIKCOMETER")) return Mikrometer;
	if(strstr((LPSTR)buf,"CHANNEL")) 		return Channel;
	return None;
	};

LPSTR __declspec(dllexport) WINAPI UnitStr(TUnitType n_unit)
	{
	switch(n_unit) {
		case Grad:			return "Grad";
		case Minuten:   return "Minuten";
		case Sekunden:  return "Sekunden";
		case Millimeter:return "Millimeter";
		case Mikrometer:return "Mikrometer";
		case Channel:   return "Channel";
		default: 				return "None";
		}
	};

void __declspec(dllexport) WINAPI Delay(long count)
	{
	// Diese Funktion keinesfalls verndern
	long d1, corr=920, m=0;
	if(count == 0) return;
	if(count>0)
		count--;
	for(d1=0;d1<(count*11+corr);d1++)
		m=m+1;

	};

void __declspec(dllexport) WINAPI DelayTime(int MilliSec)
	{
//	clock_t StartTime = clock();
//	Delay(1);
//	while((clock()-StartTime) <= MilliSec * (CLOCKS_PER_SEC/1000.0f) )
//		Delay(1);

    clock_t goal;
    goal = MilliSec + clock();
    while( goal > clock() )
       ;

	};

int __declspec(dllexport) WINAPI maxi(int value1, int value2)
	{
	return ( (value1 > value2) ? value1 : value2);
	};
int __declspec(dllexport) WINAPI mini(int value1, int value2)
	{
	return ( (value1 < value2) ? value1 : value2);
	};
long __declspec(dllexport) WINAPI maxl(long value1, long value2)
	{
	return ( (value1 > value2) ? value1 : value2);
	};
long __declspec(dllexport) WINAPI minl(long value1, long value2)
	{
	return ( (value1 < value2) ? value1 : value2);
	};
float __declspec(dllexport) WINAPI maxf(float value1, float value2)
	{
	return ( (value1 > value2) ? value1 : value2);
	};
float __declspec(dllexport) WINAPI minf(float value1, float value2)
	{
	return ( (value1 < value2) ? value1 : value2);
	};
double __declspec(dllexport) WINAPI maxd(double value1, double value2)
	{
	return ( (value1 > value2) ? value1 : value2);
	};
double __declspec(dllexport) WINAPI mind(double value1, double value2)
	{
	return ( (value1 < value2) ? value1 : value2);
	};

// __LastLine__


