
#include "msim.h"
#include "c812/mc_812.h"
#include "c832/mc_832.h"
#include "msimutil.h"
#include "export.h"

#include <windows.h>
#include <iostream.h>
#include <iomanip.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <mmsystem.h>  // timeSetEvent, timeKillEvent, timeGetTime


extern MC_812*   theMC_812;
extern MC_832*   theMC_832;
static HINSTANCE theInstance;
static HWND      theStatusWindow;
//static UINT timer_id;
//static UINT timer_count;

/*
extern "C"
{
#ifdef __BCPLUSPLUS__
#pragma argsused
#endif
  void CALLBACK UpdateProc(
    UINT  IDEvent,     // identifies timer event
    UINT  uReserved,   // not used
    DWORD dwUser,      // application-defined instance data
    DWORD dwReserved1, // not used
    DWORD dwReserved2  // not used
  )
  {
    timer_count++;
    updateSimulationStatusWindow( );
  }

} // extern "C"
*/

#ifdef __BCPLUSPLUS__
#pragma argsused
int CALLBACK LibMain( HINSTANCE hinst,
                      WORD wDataSeg, WORD cbHeap,
                      LPSTR lpszCmdLine )
{

  if ( theInstance == 0 )
  {
    theInstance = hinst;
    theMC_812 = new MC_812();
    theMC_832 = new MC_832();

    //timer_id = timeSetEvent(100, 5, UpdateProc, 0, TIME_PERIODIC);
  }

  return 1;
}

#pragma argsused
int CALLBACK WEP( int nExitType )
{
  //timeKillEvent(timer_id);

  delete theMC_812;
  delete theMC_832;

  return 1;
}
#endif


#ifdef _MSC_VER
BOOL WINAPI DllMain( HINSTANCE hinstDLL,  // handle to DLL module
                     DWORD fdwReason,     // reason for calling function
                     LPVOID lpvReserved ) // reserved 
{
  switch (fdwReason) {

  case DLL_PROCESS_ATTACH:
    if ( theInstance == 0 )
    {
      theInstance = hinstDLL;
      theMC_812 = new MC_812();
      theMC_832 = new MC_832();

      //timer_id = timeSetEvent(100, 5, UpdateProc, 0, TIME_PERIODIC);
    }
    return TRUE;

  case DLL_PROCESS_DETACH:
    //timeKillEvent(timer_id);

    delete theMC_812;
    delete theMC_832;
    
    return TRUE;
  }
}
#endif

#ifdef __BCPLUSPLUS__
  MC_812* MSIMAPI getTheC812() { return theMC_812; }
  MC_832* MSIMAPI getTheC832() { return theMC_832; }
#else
  MSIMAPI MC_812* getTheC812() { return theMC_812; }
  MSIMAPI MC_832* getTheC832() { return theMC_832; }
#endif


extern "C"
{

  char WINAPI SILENT_C812ISA_GET_CALLBACK ( char* addr, char )
  {
    return theMC_812 -> Get( addr );
  }

  char WINAPI VERBOSE_C812ISA_GET_CALLBACK_TS ( char* addr, char hw_value )
  {
    char ret_val = theMC_812 -> Get( addr );
    ostream* log = theMC_812 -> GetLogStream();

    if ( log && theMC_812 -> GetLogLevel() > 1 )
    {

      *log << "<output>C812ISA get " << ( void* ) addr << " "
           << "</output>" << endl;

      *log << "<input src='hw'>" << setbase( 16 ) << setw( 2 ) << setfill( 48 )
           << ( ( int ) hw_value & 0xFF );
      if ( hw_value >= 0x20 )
      {
        switch ( hw_value )
        {
          case 0x26:
            *log << " = &amp;";
            break;
          case 0x3c:
            *log << " = &lt;";
            break;
          default:
            *log << " = " << hw_value;
        }
      }

      *log << "</input>" << endl;

      *log << "<input src='sim'>"
           << setbase( 16 )  << setw( 2 )  << setfill( 48 )
           << ( ( int ) ret_val & 0xFF );
      if ( ret_val >= 0x20 )
      {
        switch ( ret_val )
        {
          case 0x26:
            *log << " = &amp;";
            break;
          case 0x3c:
            *log << " = &lt;";
            break;
          default:
            *log << " = " << ret_val;
        }
      }
      *log << "</input>" << endl;

      if ( ret_val == hw_value )
        *log << "<sim-test>pass</sim-test>";
      else
        *log << "<sim-test>fail</sim-test>";

      *log << endl << setbase( 10 );
    }

    return ret_val;
  }

  char WINAPI VERBOSE_C812ISA_GET_CALLBACK_SO ( char* addr, char )
  {
    char ret_val = theMC_812 -> Get( addr );
    ostream* log = theMC_812 -> GetLogStream();

    if ( log && theMC_812 -> GetLogLevel()  > 1 )
    {

      *log << "<output>C812ISA get " << (void*)addr << " "
           << "</output>" << endl;

      *log << "<input src='sim'>"
           << setbase( 16 )  << setw( 2 ) << setfill( 48 )
           << ( ( int ) ret_val & 0xFF );
      if ( ret_val >= 0x20 )
      {
        switch ( ret_val )
        {
          case 0x26:
            *log << " = &amp;";
            break;
          case 0x3c:
            *log << " = &lt;";
            break;
          default:
            *log << " = " << ret_val;
        }
      }

      *log << "</input>" << endl << setbase( 10 );
    }

    return ret_val;
  }

  char WINAPI VERBOSE_C812ISA_GET_CALLBACK_NS ( char* addr, char hw_value )
  {
    ostream* log = theMC_812 -> GetLogStream();

    if ( log && theMC_812 -> GetLogLevel()  > 1 )
    {

      *log << "<output>C812ISA get " << ( void* ) addr << " "
           << "</output>" << endl;

      *log << "<input src='hw'>" << setbase( 16 ) << setw( 2 ) << setfill( 48 )
           << ( ( int ) hw_value & 0xFF );
      if ( hw_value >= 0x20 )
      {
        switch ( hw_value )
        {
          case 0x26:
            *log << " = &amp;";
            break;
          case 0x3c:
            *log << " = &lt;";
            break;
          default:
            *log << " = " << hw_value;
        }
      }
      *log << "</input>" << endl << setbase( 10 );
    }
    return 0;
  }

  void WINAPI SILENT_C812ISA_PUT_CALLBACK ( char* addr, char put )
  {
    theMC_812 -> Put( addr, put );
  }

  void WINAPI VERBOSE_C812ISA_PUT_CALLBACK ( char* addr, char put )
  {
    ostream* log = theMC_812 -> GetLogStream();

    if ( log && theMC_812 -> GetLogLevel()  > 1 )
    {
      *log << "<output>C812ISA put " << ( void* ) addr << " "
           << setbase( 16 ) << setw( 2 ) << setfill( 48 )
           << ( int ) put;
      if ( put > 0x20 )
      {
        switch ( put )
        {
          case 0x26:
            *log << " = &amp;";
            break;
          case 0x3c:
            *log << " = &lt;";
            break;
          default:
            *log << " = " << put;
        }
      }
      *log << "</output>" << endl << setbase( 10 );
    }
    theMC_812 -> Put( addr, put );
  }


  // 832

  int WINAPI SILENT_C832_GET_CALLBACK ( unsigned port, int )
  {
    return theMC_832 -> Get( port );
  }

  int WINAPI VERBOSE_C832_GET_CALLBACK_TS ( unsigned port, int hw_value )
  {
    char ret_val;
    ostream* log = theMC_832 -> GetLogStream();

    if ( log && theMC_832 -> GetLogLevel()  > 1 )
    {
      *log << "<output>C832 get " << setbase( 16 )  << port
           << "</output>" << endl;
    }

    ret_val = theMC_832 -> Get( port );

    if ( log && theMC_832 -> GetLogLevel()  > 1 )
    {
      *log << "<input src='hw'>" << binary( ( char ) hw_value )
           << "</input>" << endl
           << "<input src='sim'>" << binary( ( char ) ret_val )
           << "</input>" << endl;

      if ( ret_val == hw_value )
        *log << "<sim-test>pass</sim-test>";
      else
        *log << "<sim-test>fail</sim-test>";
      *log <<  endl << setbase( 10 );
    }

    return ret_val;
  }

  int WINAPI VERBOSE_C832_GET_CALLBACK_SO ( unsigned port, int )
  {
    char ret_val;
    ostream* log = theMC_832 -> GetLogStream();

    if ( log && theMC_832 -> GetLogLevel()  > 1 )
    {
      *log << "<output>C832 get " << setbase( 16 ) << port
           << "</output>" << endl;
    }

    ret_val = theMC_832 -> Get( port );

    if ( log && theMC_832 -> GetLogLevel()  > 1 )
    {
      *log << "<input src='sim'>" << binary( ( char ) ret_val )
           << "</input>" << endl;
    }

    return ret_val;
  }

  int WINAPI VERBOSE_C832_GET_CALLBACK_NS ( unsigned port, int hw_value )
  {
    ostream* log = theMC_832 -> GetLogStream();

    if ( log && theMC_832 -> GetLogLevel()  > 1 )
    {

      *log << "<output>C832 get " << setbase( 16 )  << port
           << "</output>" << endl;

      *log << "<input src='hw'>" << binary( ( char ) hw_value )
           << "</input>" << endl;
    }
    return 0;
  }

  void WINAPI SILENT_C832_PUT_CALLBACK ( unsigned port, int put )
  {
    theMC_832 -> Put(  port, put );
  }

  void WINAPI VERBOSE_C832_PUT_CALLBACK ( unsigned port, int put )
  {
    ostream* log = theMC_832 -> GetLogStream();

    if ( log && theMC_832 -> GetLogLevel()  > 1 )
    {
      *log << "<output>C832 put " << setbase( 16 )  << port
           << " " << binary( ( char ) put )
           << "</output>" << endl << setbase( 10 );
    }

    theMC_832 -> Put(  port, put );
  }

char motor[100] = "MotorXXX";
  //
  // usage: InitControllerFromIniFile(GetHWFile());
  //

  void WINAPI initControllerFromInifile( const char* inifile )
  {
    char buffer[ 100 ];
    int board_id;
    long long_val, phys_pos, phys_pos_range, hysteresis, direction;
    bool c812_ramaddr_set = false;
    bool c832_ioaddr_set = false;
    double double_val = 0;
    int i = 0;


    GetPrivateProfileString( "MOTORSIM", "LogLevel", "0", buffer, 100, inifile );
    long_val = strtol( buffer, 0, 10 );
    theMC_812 -> SetLogLevel( (int)long_val );
    theMC_832 -> SetLogLevel( (int)long_val );

    GetPrivateProfileString( "MOTORSIM", "BuysProp", "0", buffer, 100, inifile );
    sscanf( buffer, "%lg", &double_val );
    theMC_812 -> SetControllerBusyProbability( min( max( double_val,0.0 ),1.0 ) );

    while( 1 )
    {
      sprintf( motor, "Motor%i", i );

      GetPrivateProfileString( motor, "Type", "", buffer, 100, inifile );

      // no more motors in ini file?
      if ( buffer[ 0 ] == 0 )  break;


      //
      // determine the "hardware restrictions" given in ini-file
      //
      // the motor stands on following phys. position (dist. from the
      // lower "hardware" switch):
      //    hwswDistance - PositionMin + DeltaPosition
      // the distance between the two simulated hardware limits:
      //  (PositionMax + hwswDistance) - (PositionMin - hwswDistance)
      //   = PositionMax - PositionMin + 2 * hwswDistance
      //
      GetPrivateProfileString( motor, "PositionMax", "100",
                               buffer, 100, inifile );
      phys_pos_range = strtol( buffer, 0, 10 );

      GetPrivateProfileString( "MOTORSIM", "hwswDistance", "4000",
                               buffer, 100, inifile );
      phys_pos = strtol( buffer, 0, 10 );
      phys_pos_range += 2 * strtol( buffer, 0, 10 );

      GetPrivateProfileString( motor, "PositionMin", "0",
                               buffer, 100, inifile );
      phys_pos -= strtol( buffer, 0, 10 );
      phys_pos_range -= strtol( buffer, 0, 10 );

      GetPrivateProfileString( motor, "DeltaPosition", "0",
                               buffer, 100, inifile );
      phys_pos += strtol( buffer, 0, 10 );

      GetPrivateProfileString( motor, "PositionOffset", "0",
                               buffer, 100, inifile );
      phys_pos += strtol( buffer, 0, 10 );

      // hysteresis and last direction
      GetPrivateProfileString( motor, "Hysteresis", "0",
                               buffer, 100, inifile );
      hysteresis = strtol( buffer, 0, 10 );
      GetPrivateProfileString( motor, "Upwards", "0",
                               buffer, 100, inifile );
      direction = strtol( buffer, 0, 10 );


      GetPrivateProfileString( motor, "Type", "", buffer, 100, inifile );

      if ( strcmp( buffer, "C-812ISA" ) == 0 )
      {
        GetPrivateProfileString( motor, "BoardId", "1", buffer, 100, inifile );
        board_id = atoi( buffer );

        if ( ! ( 1 <= board_id && board_id <= 4 ) )  goto next;

        // only the first RamAddr in the ini-file is used
        if ( !c812_ramaddr_set )
        {
          GetPrivateProfileString( motor, "RamAddr", "0xD000", buffer, 100, inifile );
          long_val = strtol( buffer, 0, 16 );
          theMC_812 -> SetBaseAddr( (unsigned)long_val );
          c812_ramaddr_set = true;
        }

        theMC_812 -> SetPhysicalPosition( board_id, phys_pos );
        theMC_812 -> SetPhysicalPositionRange( board_id, phys_pos_range );
        theMC_812 -> SetHysteresis( board_id, hysteresis );
        theMC_812 -> SetLastDirection( board_id, direction?true:false );
      }
      else if ( strcmp( buffer, "C-832" ) == 0 )
      {
        GetPrivateProfileString( motor, "BoardId", "1", buffer, 100, inifile );
        board_id = atoi( buffer );

        if ( ! ( 0 <= board_id && board_id <= 1 ) )  goto next;

        if ( !c832_ioaddr_set )
        {
          GetPrivateProfileString( motor, "IOAddr", "0x210",
                                   buffer, 100, inifile );
          long_val = strtol( buffer, 0, 16 );
          theMC_832 -> SetIOAddress( (unsigned)long_val );
          c832_ioaddr_set = true;
        }
        theMC_832 -> SetPhysicalPosition( board_id, phys_pos );
        theMC_832 -> SetPhysicalPositionRange( board_id, phys_pos_range );
        theMC_832 -> SetHysteresis( board_id, hysteresis );
        theMC_832 -> SetLastDirection( board_id, direction?true:false );

        GetPrivateProfileString( motor, "IndexLine", "0",
                                 buffer, 100, inifile );
        long_val = strtol( buffer, 0, 10 );
        if ( long_val == 1 )
        {
          GetPrivateProfileString( "MOTORSIM", "IndexPosition", "5000",
                                   buffer, 100, inifile );
          long_val = strtol( buffer, 0, 10 );
          theMC_832 -> SetPhysicalIndexPosition( board_id, long_val );
        }

      }

next:
      ++i;
    }
  }

  void WINAPI setSimulationStatusWindow( HWND hwnd )
  {
    theStatusWindow = hwnd;
  }

  void WINAPI setLogStream( ostream* s )
  {
    theMC_812 -> SetLogStream( s );
    theMC_832 -> SetLogStream( s );
  }

  void WINAPI updateSimulationStatusWindow()
  {
    static DWORD last_update = 0;
    DWORD current_time;
    char buffer[ 1024 ];

    current_time = timeGetTime();
    if (current_time - last_update > 10) {
      buffer[ 0 ] = 0;

      strcat( buffer, "C812\r\n" );
      strcat( buffer, theMC_812 -> GetStatusText() );
      strcat( buffer, "C832\r\n" );
      strcat( buffer, theMC_832 -> GetStatusText() );

      if ( theStatusWindow )
      {
        SendMessage( theStatusWindow, WM_SETTEXT, 0, (LPARAM) buffer );
        UpdateWindow( theStatusWindow );
      }
    }
    last_update = current_time;
  }

} // extern "C"


