
#ifndef _MSIMUTIL_H_
#define _MSIMUTIL_H_

#include <iostream.h>
#include <iomanip.h>


#ifdef __BCPLUSPLUS__
#pragma warn -inl // Functions containing for are not expanded inline
typedef char byte;
#endif

// outputs a 8 bit integer as binary number
inline ostream& _binary( ostream& os, char value )
{
  for( int i=0x80; i>0; i>>=1 )
  {
    os << ( ( i & value )  ? '1' : '0' );
  }
  return os;
}
inline ostream& _binary( ostream& os, short value )
{
  for( long i=0x8000; i>0; i>>=1 )
  {
    os << ( ( i & value )  ? '1' : '0' );
  }
  return os;
}

#ifdef __BCPLUSPLUS__
#pragma warn .inl
// and the corresponding ostream manipulator
inline omanip<char> binary( char value )
{
  return omanip<char>( _binary, value );
}
inline omanip<short> binary( short value )
{
  return omanip<short>( _binary, value );
}

#endif


#if _MSC_VER 
IOMANIPdeclare(char)
IOMANIPdeclare(short)

inline OMANIP( char )  binary( char value )
{
  return OMANIP( char ) ( _binary, value );
}
inline OMANIP( short )  binary( short value )
{
  return OMANIP( short ) ( _binary, value );
}

inline
ostream& setbase( ostream& os, int base )
{
  switch( base )
  {
    case 8:
      os.setf( ios::oct );
      break;
    case 16:
      os.setf( ios::hex );
      break;
    default:
      os.setf( ios::dec );
      break;
  }
  return os;
}
inline OMANIP( int )  setbase( int v )
{
  return OMANIP( int ) ( setbase, v );
}
#endif


template<class T>
inline bool between( T value, T left, T right )
{
  return ( left <= value && value <= right ) || ( right <= value && value <= left );
}

// helper for accessing a short int bytewise
union short_bytes {
  short short_val;
  byte  bytes[ 2 ];
};
// helper for accessing a long int bytewise
union long_bytes {
  long long_val;
  byte bytes[ 4 ];
};



#endif // _MSIMUTIL_H_

